VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "EmpSectorMarker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Dim sm As New Collection
Const SECTOR_MARKER_DURATION = 5 'default duration in minutes


Public Sub Add(sx As Integer, sy As Integer, Nation As Integer, Message As String)

Dim col As Collection
Dim ncol As New Collection

'first look for it
For Each col In sm
    If col.Item("x") = sx And col.Item("y") = sy Then
        col.Remove "msg"
        col.Remove "ts"
        col.Remove "nation"
        col.Add Message, "msg"
        col.Add Now, "ts"
        col.Add Nation, "nation"
        Exit Sub
    End If
Next col

ncol.Add sx, "x"
ncol.Add sy, "y"
ncol.Add Message, "msg"
ncol.Add Nation, "nation"
ncol.Add Now, "ts"

sm.Add ncol

End Sub

Public Function Find(sx As Integer, sy As Integer) As String

Dim col As Collection

'first look for it
For Each col In sm
    If col.Item("x") = sx And col.Item("y") = sy Then
        Find = col.Item("msg")
        Exit Function
    End If
Next col

Find = ""

End Function

Public Sub Clear()

While Me.Count > 0
    Me.Remove 1
Wend

End Sub

Public Function Count() As Integer
Count = sm.Count
End Function

Public Function X(Index As Integer) As Integer
If Index < 1 Or Index > sm.Count Then
    X = 0
    Exit Function
End If

X = sm.Item(Index).Item("x")
End Function
Public Function Y(Index As Integer) As Integer
If Index < 1 Or Index > sm.Count Then
    Y = 0
    Exit Function
End If
Y = sm.Item(Index).Item("y")
End Function
Public Function Message(Index As Integer) As String
If Index < 1 Or Index > sm.Count Then
    Message = ""
    Exit Function
End If
Message = sm.Item(Index).Item("msg")
End Function
Public Function Nation(Index As Integer) As Integer
If Index < 1 Or Index > sm.Count Then
    Nation = 0
    Exit Function
End If
Nation = sm.Item(Index).Item("nation")
End Function

Public Sub Remove(Index As Integer)
Dim col As Collection
Set col = sm.Item(Index)
col.Remove "x"
col.Remove "y"
col.Remove "msg"
col.Remove "ts"
sm.Remove Index
End Sub
Public Sub RemoveExpired()

Dim col As Collection
Dim n As Integer
For n = sm.Count To 1 Step -1
    Set col = sm.Item(n)
    If Now > DateAdd("n", CDbl(SECTOR_MARKER_DURATION), col.Item("ts")) Then
        Me.Remove n
    End If
Next n

End Sub
