Attribute VB_Name = "WinAceRoutines"
Option Explicit

'EmpCmd Constants for seting expected empire results
Public Const READ_STATE_FIRSTSERVERINIT = 1
Public Const READ_STATE_USERCMDOK = 2
Public Const READ_STATE_COUNCMDOK = 3
Public Const READ_STATE_PASSCMDOK = 4
Public Const READ_STATE_KILLPROC = 5
Public Const READ_STATE_PLAYINIT = 6
Public Const READ_STATE_SECTOR_DUMP = 7
Public Const READ_STATE_PLANE_DUMP = 8
Public Const READ_STATE_LAND_DUMP = 9
Public Const READ_STATE_SHIP_DUMP = 10
Public Const READ_STATE_FULL_BMAP = 11
Public Const READ_STATE_REPORT = 12
Public Const READ_STATE_REQ_REPORT = 13
Public Const READ_STATE_REQ_RELATIONS = 14
Public Const READ_STATE_EXPLORE_CIRCLE = 15
Public Const READ_STATE_UNIT_MOVE = 16
Public Const READ_STATE_NEXT_UPDATE = 17
Public Const READ_STATE_FIRE_SEQ = 18
Public Const READ_STATE_LAUNCH = 19
Public Const READ_STATE_BOMB = 20
Public Const READ_STATE_TELEGRAM_READ = 21
Public Const READ_STATE_TELEGRAM_WRITE = 22
Public Const READ_STATE_LOOK = 23
Public Const READ_STATE_SPY = 24
Public Const READ_STATE_RECON = 25
Public Const READ_STATE_COASTWATCH = 26
Public Const READ_STATE_ATTACK = 27
Public Const READ_STATE_VERSION = 28
Public Const READ_STATE_LOST_DUMP = 29
Public Const READ_STATE_ORIGIN = 30
Public Const READ_STATE_LISTSANC = 31
Public Const READ_STATE_STARVATION = 32
Public Const READ_STATE_SONAR = 33
Public Const READ_STATE_SHOW = 34
Public Const READ_STATE_PARA = 35
Public Const READ_STATE_BREAK = 36
Public Const READ_STATE_NATION = 37
Public Const READ_STATE_NUKE_DUMP = 38
Public Const READ_STATE_BOMBCL = 39
Public Const READ_STATE_ORDER = 40
Public Const READ_STATE_SHOWORDER = 41
Public Const READ_STATE_LANDMISSION = 42
Public Const READ_STATE_SHIPMISSION = 43
Public Const READ_STATE_PLANEMISSION = 44
Public Const READ_STATE_EDIT = 45
Public Const READ_STATE_TELEGRAM_READ_CL = 46
Public Const READ_STATE_WIRE = 47

Public Const TYPE_ALL = 0
Public Const TYPE_CAPITAL = 1
Public Const TYPE_ESCORT = 2
Public Const TYPE_SUPPORTSHIP = 3
Public Const TYPE_SUB = 4
Public Const TYPE_CARRIER = 5
Public Const TYPE_TROOPSHIPS = 6
Public Const TYPE_MERCHANTS = 7
Public Const TYPE_FIGHTERS = 8
Public Const TYPE_BOMBERS = 9
Public Const TYPE_ESCORTPLANES = 10
Public Const TYPE_TRANSPORTS = 11
Public Const TYPE_RECON = 12
Public Const TYPE_MISSILES = 13
Public Const TYPE_SATELLITES = 14
Public Const TYPE_CHOPPER = 15
Public Const TYPE_ANTISUB = 16
Public Const TYPE_COMBAT = 17
Public Const TYPE_ARTILLERY = 18
Public Const TYPE_SUPPORT = 19
Public Const TYPE_ENGINEERS = 20
Public Const TYPE_OTHER = 21
Public Const TYPE_RESTORE = 99

Public Const BF_NEVERABORT = 0

Public Const BF_ABORTONRETURNFIRE = 1
Public Const BF_ABORTREMAINING = 2


Public Const DSP_SHIP = 1
Public Const DSP_LAND = 2
Public Const DSP_PLANE = 3
Public Const DSP_ENEMY = 4
Public Const DSP_LIST = 5

Public Const DSP_ALL = 1
Public Const DSP_FLEET = 2
Public Const DSP_SECT = 3
Public Const DSP_PLANE_RANGE = 4
Public Const DSP_MISSILE_RANGE = 5
Public Const DSP_ATTACK_RANGE = 6

Public Const MaxExploreRadius = 10

Public MapSizeX As Integer
Public MapSizeY As Integer
Public bDeity As Boolean

Public TimeIdle As Long

Public picGreenLight As Picture
Public picRedLight As Picture
Public picBothLights As Picture

Public Nations As New EmpNationList
Public CountryNumber As Integer

Public BatchScript1File As String
Public BatchScript1Time As Long
Public BatchScriptUpdate As String


Sub LoadPictures()
On Error GoTo Empire_Error
Set picLand = LoadPicture(App.Path + "\land.gif")
Set picShip = LoadPicture(App.Path + "\ship.gif")
Set picPlane = LoadPicture(App.Path + "\plane.gif")
Set picEnemyLand = LoadPicture(App.Path + "\eland.gif")
Set picFriendlyLand = LoadPicture(App.Path + "\fland.gif")
Set picEnemyShip = LoadPicture(App.Path + "\eship.gif")
Set picNeutralShip = LoadPicture(App.Path + "\nship.gif")
Set picFriendlyShip = LoadPicture(App.Path + "\fship.gif")
Set picEnemyPlane = LoadPicture(App.Path + "\eplane.gif")
Set picGreenLight = LoadPicture(App.Path + "\light.gif")
Set picRedLight = LoadPicture(App.Path + "\light2.gif")
Set picBothLights = LoadPicture(App.Path + "\light3.gif")
Exit Sub
Empire_Error:
EmpireError "LoadPictures", "", ""
End Sub

Public Sub LoadBmap(buf As String, Startx As Integer, linelen As Integer)
Dim CurY As Integer
Dim CurX As Integer
Dim x As Integer
Dim fieldname As String
Dim BufferLen As Integer

On Error GoTo LoadBmap_Exit

CurY = val(Left(buf, 4))

'Figure out how far bmap goes
BufferLen = Len(buf)
If linelen < BufferLen Then
    BufferLen = linelen
End If

If Left(buf, 4) = "    " Then
    Exit Sub
End If

For x = 5 To BufferLen
    If Mid(buf, x, 1) <> " " Then
        CurX = Startx + x - 6
        rsBmap.Seek "=", CurX, CurY
        If rsBmap.NoMatch Then
            rsBmap.AddNew
            fieldname = "x"
            rsBmap.Fields(fieldname) = CurX
            fieldname = "y"
            rsBmap.Fields(fieldname) = CurY
            fieldname = "des"
            rsBmap.Fields(fieldname) = Mid(buf, x, 1)
            rsBmap.Update
        ElseIf rsBmap.Fields("des") <> Mid(buf, x, 1) Then
            rsBmap.Edit
            fieldname = "des"
            rsBmap.Fields(fieldname) = Mid(buf, x, 1)
            rsBmap.Update
        End If
    End If
Next x
Exit Sub

'Error handling routine
LoadBmap_Exit:
On Error Resume Next
EmpireError "LoadBmap", fieldname, buf

End Sub
Public Sub ImportBmap()
On Error GoTo Empire_Error
Dim CurY As Integer
Dim CurX As Integer
Dim x As Integer
Dim BufferLen As Integer
Dim filenumber As Integer
Dim FileName As String
Dim bdes As String


ChDir App.Path

Load frmCommonDialog
' Set CancelError is True
frmCommonDialog.cdb.CancelError = True
' Set flags
frmCommonDialog.cdb.FLAGS = cdlOFNHideReadOnly
' Set filters
frmCommonDialog.cdb.Filter = "All Files (*.*)|*.*|Text Files" & _
"(*.txt)|*.txt"
' Specify default filter
frmCommonDialog.cdb.FilterIndex = 2
' Display name of selected file
frmCommonDialog.cdb.FileName = ""

' Display the open dialog box
On Error GoTo ImportBmap_Exit
frmCommonDialog.cdb.ShowOpen
On Error GoTo Empire_Error

'frmCommonDialog.cdb.FileTitle

FileName = frmCommonDialog.cdb.FileName
filenumber = FreeFile   ' Get unused file number.
Open FileName For Input As #filenumber

Dim Line As Integer
Dim bmaphead1 As String
Dim bmaphead2 As String
Dim bmaphead3 As String
Dim Startx As Integer
Dim AdjX As Integer
Dim AdjY As Integer
Dim temp As Integer
Dim linelen As Integer
Dim overwrite As Boolean
Dim strLine As String
Dim strSect As String

start:
strSect = InputBox("Enter your x,y co-ordinates for the imported bmaps origin")
If Not ParseSectors(AdjX, AdjY, strSect) Then
    If MsgBox("Sectors not valid", vbRetryCancel + vbCritical, "Import Bmap Error") = vbRetry Then
        GoTo start
    End If
    Exit Sub
End If

overwrite = (MsgBox("Do you want to overwrite your existing bmap", vbYesNo + vbQuestion, "Import Bmap") = vbYes)
    
While Not EOF(filenumber)
    Line Input #filenumber, strLine
    Line = Line + 1
    If Line = 1 Then
        bmaphead1 = strLine
        linelen = Len(RTrim(bmaphead1))
    ElseIf Line = 2 Then
        bmaphead2 = strLine
        'Calculate the starting x
        Startx = val(Mid(bmaphead1, 6, 1)) * 10 + val(Mid(bmaphead2, 6, 1))
        temp = val(Mid(bmaphead1, 7, 1)) * 10 + val(Mid(bmaphead2, 7, 1))
        If temp < Startx Then
            Startx = -1 * Startx
        End If
    ElseIf Line = 3 And Left(strLine, 4) = "    " Then
        'Handle three line bmap - recompute start x
        bmaphead3 = strLine
        Startx = val(Mid(bmaphead1, 6, 1)) * 100 + val(Mid(bmaphead2, 6, 1)) * 10 + val(Mid(bmaphead3, 6, 1))
        temp = val(Mid(bmaphead1, 7, 1)) * 100 + val(Mid(bmaphead2, 7, 1)) * 10 + val(Mid(bmaphead3, 7, 1))
        If temp < Startx Then
            Startx = -1 * Startx
        End If
    Else
        CurY = val(Left(strLine, 4)) + AdjY
        
        'Figure out how far bmap goes
        BufferLen = Len(strLine)
        If linelen < BufferLen Then
            BufferLen = linelen
        End If
        
        If Left(strLine, 4) <> "    " Then
            For x = 5 To BufferLen
                If Mid(strLine, x, 1) <> " " Then
                    CurX = Startx + x - 6 + AdjX
                    
                    'Adjust the x and y to compesate for
                    'going over the boundry
                    OffsetSectorLocation CurX, CurY, 0, 0
                    
                    'process sector by sector
                    bdes = Mid(strLine, x, 1)
                    If bdes = "?" Then
                        bdes = "0"
                    End If
                    
                    rsBmap.Seek "=", CurX, CurY
                    If rsBmap.NoMatch Then
                        frmEmpCmd.SubmitEmpireCommand "bdes " + SectorString(CurX, CurY) _
                             + " " + bdes, False
                    ElseIf rsBmap.Fields("des") <> bdes Then
                        'check and make sure land and water line up with
                        'current bmap
                        If (InStr(".=X", rsBmap.Fields("des")) > 0 And _
                            InStr(".=X", bdes) = 0) Or _
                           (InStr(".=X", rsBmap.Fields("des")) = 0 And _
                            InStr(".=X", bdes) > 0) Then
                            
                            If MsgBox("Warning.  Possible error in bmap lineup. " + _
                             "Current Bmap shows '" + rsBmap.Fields("des") + "', imported bmap shows '" + _
                             bdes + "' Do you want to continue?", vbExclamation + vbYesNo, "Import Bmap") _
                              = vbNo Then Exit Sub
                        End If
                        If overwrite Then
                            frmEmpCmd.SubmitEmpireCommand "bdes " + SectorString(CurX, _
                                CurY) + " " + bdes, False
                        'alway mark map if minefield
                        ElseIf rsBmap.Fields("des") = "." And bdes = "X" Then
                            frmEmpCmd.SubmitEmpireCommand "bdes " + SectorString(CurX, _
                                CurY) + " " + bdes, False
                        End If
                    End If
                End If
            Next x
        End If
    End If
Wend
Exit Sub

'Error handling routine
ImportBmap_Exit:
Exit Sub
Empire_Error:
EmpireError "ImportBmap", "", ""

End Sub

Public Sub RefreshDataBase()
On Error GoTo Empire_Error
frmEmpCmd.ForceUpdates = True

'Send Code to start database update
frmEmpCmd.SubmitEmpireCommand "db1", False

'Request an update to find when the next update is
frmEmpCmd.SubmitEmpireCommand "update", False

'If version information needs filling, request version
If rsVersion.BOF And rsVersion.EOF Then
    frmEmpCmd.SubmitEmpireCommand "version", False
End If

'If nation information needs filling, request version
If rsNations.BOF And rsNations.EOF Then
    frmEmpCmd.SubmitEmpireCommand "report *", False
    frmEmpCmd.SubmitEmpireCommand "relation", False
End If

'update info about this nation
frmEmpCmd.SubmitEmpireCommand "nation", False

'Request an update of Sector information
frmEmpCmd.SubmitEmpireCommand "dump * ?timestamp>" + CStr(tsSectors), False

'Request an update of Plane information
frmEmpCmd.SubmitEmpireCommand "pdump * ?timestamp>" + CStr(tsPlane), False

'Request an update of land information
frmEmpCmd.SubmitEmpireCommand "ldump * ?timestamp>" + CStr(tsLand), False

'Request an update of ship information
frmEmpCmd.SubmitEmpireCommand "sdump * ?timestamp>" + CStr(tsShip), False

'Request an update of nuke information
frmEmpCmd.SubmitEmpireCommand "ndump * ", False

'Request update lost information
frmEmpCmd.SubmitEmpireCommand "lost * ?timestamp>" + CStr(tsLost), False

'Request an update of ship information
frmEmpCmd.SubmitEmpireCommand "bmap *", False

'send Code to end database update
frmEmpCmd.SubmitEmpireCommand "db2", False
Exit Sub
Empire_Error:
EmpireError "RefreshDataBase", "", ""
End Sub
Public Function ProcessSectorDump(strLine As String, ByRef CurX As Integer, ByRef CurY As Integer) As String

Dim strTokens() As String
Dim top As Integer
Dim numTokens As Integer
Dim i As Integer
Dim n As Integer
Dim hldindex
Dim var As String
On Error GoTo ProcessSectorDump_Exit

'check for an announcement or tele message in the middle of a dump
If InStr(strLine, "You have") > 0 Then
    ProcessSectorDump = ""
    Exit Function
End If

'Save and restore the index on entry and exit
hldindex = rsSectors.Index
rsSectors.Index = "PrimaryKey"

ParseDumpString strLine, strTokens(), bDeity

numTokens = UBound(strTokens)
For n = LBound(strTokens) To numTokens
    If n > 3 Or n = 2 Then
        var = rsSectors.Fields(n).Name
        rsSectors.Fields(n) = strTokens(n)
    ElseIf n = 3 Then
        var = rsSectors.Fields(n).Name
        If strTokens(n) = "_" Then
            strTokens(n) = " "
        End If
        rsSectors.Fields(n) = strTokens(n)
    ElseIf n = 0 Then
        CurX = CInt(strTokens(n))
    Else
        CurY = CInt(strTokens(n))
        rsSectors.Seek "=", CurX, CurY
        If rsSectors.NoMatch Then
            rsSectors.AddNew
        Else
            rsSectors.Edit
        End If
        var = rsSectors.Fields(0).Name
        rsSectors.Fields(0) = CurX
        rsSectors.Fields(1) = CurY
    End If
Next n
rsSectors.Update
hldindex = rsSectors.Index
ProcessSectorDump = strTokens(0) + "," + strTokens(1)
Exit Function

'Error handling routine
ProcessSectorDump_Exit:
EmpireError "ProcessSectorDump", var, strLine
ProcessSectorDump = ""
End Function
Public Sub ProcessLostDump(strLine As String)

Dim strTokens() As String
Dim top As Integer
Dim numTokens As Integer
Dim CurX As Integer
Dim CurY As Integer
Dim i As Integer
Dim n As Integer
On Error GoTo ProcessLostDump_Exit

'Since Deity gets all information, he doesn't process a lost dump.
'Simplest way around problem of items lost to player A were deleting
'entries for the same item that were rebuilt by player B
If bDeity Then
    Exit Sub
End If

'check for an announcement or tele message in the middle of a dump
If InStr(strLine, "You have") > 0 Then
    Exit Sub
End If

ParseDumpString strLine, strTokens(), bDeity
numTokens = UBound(strTokens)

Select Case strTokens(LS_TYPE)
    Case LT_SECTOR
        rsSectors.Seek "=", CInt(strTokens(LS_X)), CInt(strTokens(LS_Y))
        If Not rsSectors.NoMatch Then
            rsSectors.Delete
        End If
        
    Case LT_SHIP
        rsShip.Seek "=", CInt(strTokens(LS_ID))
        If Not rsShip.NoMatch Then
            rsShip.Delete
        End If
    Case LT_PLANE
        rsPlane.Seek "=", CInt(strTokens(LS_ID))
        If Not rsPlane.NoMatch Then
            rsPlane.Delete
        End If
    Case LT_LAND
        rsLand.Seek "=", CInt(strTokens(LS_ID))
        If Not rsLand.NoMatch Then
            rsLand.Delete
        End If
End Select
Exit Sub

'Error handling routine
ProcessLostDump_Exit:
EmpireError "ProcessLostDump", "", strLine

End Sub
Public Sub ProcessDump(strLine As String, ByRef rs As Recordset)

Dim strTokens() As String
Dim top As Integer
Dim numTokens As Integer
Dim CurX As Integer
Dim CurY As Integer
Dim i As Integer
Dim n As Integer
Dim id As Long
Dim hldindex
Dim var As String

On Error GoTo ProcessDump_Exit

'check for an announcement or tele message in the middle of a dump
If InStr(strLine, "You have") > 0 Then
    Exit Sub
End If

'Save and restore the index on entry and exit
hldindex = rs.Index
rs.Index = "PrimaryKey"

ParseDumpString strLine, strTokens(), bDeity
numTokens = UBound(strTokens)
For n = LBound(strTokens) To numTokens
    var = rs.Fields(n).Name
    If n > 0 Then
        'if this is a ship name, strip the quotes
        If Len(strTokens(n)) > 1 Then
            If Asc(strTokens(n)) = 34 Then
                strTokens(n) = Mid(strTokens(n), 2, Len(strTokens(n)) - 2)
            End If
        End If
        If InStr(strTokens(n), ".") Then
            'if there is a decimal, we need to use Val to force the
            'conversion NOT to be internationally aware,
            'since some countries use a comma for the decimal
            'point, and the empire server always uses a period.
            rs.Fields(n) = val(strTokens(n))
        Else
            rs.Fields(n) = strTokens(n)
        End If
    Else
        id = CInt(strTokens(n))
        rs.Seek "=", id
        If rs.NoMatch Then
            rs.AddNew
        Else
            rs.Edit
        End If
        rs.Fields(0) = id
    End If
Next n
rs.Update
rs.Index = hldindex

Exit Sub

'Error handling routine
ProcessDump_Exit:
EmpireError "ProcessDump", var, strLine

End Sub
Public Sub ProcessNukeDump(strLine As String, ByRef rs As Recordset)

Dim strTokens() As String
Dim top As Integer
Dim numTokens As Integer
Dim CurX As Integer
Dim CurY As Integer
Dim i As Integer
Dim n As Integer
Dim id As Long
Dim hldindex
Dim var As String

On Error GoTo ProcessNukeDump_Exit

ParseDumpString strLine, strTokens(), bDeity

numTokens = UBound(strTokens)
rs.AddNew 'every nuke is a new line
For n = LBound(strTokens) To numTokens
    var = rs.Fields(n).Name
    rs.Fields(n) = strTokens(n)
Next n
rs.Update

Exit Sub

'Error handling routine
ProcessNukeDump_Exit:
EmpireError "ProcessNukeDump", var, strLine

End Sub

Public Sub BlitzSetup(Initial As Boolean, sx1 As Integer, sy1 As Integer, sx2 As Integer, sy2 As Integer)
On Error GoTo Empire_Error

Dim strSect As String
Dim Cap As String
Dim Harbour As String
Dim Oil As String
Dim x As Integer
Dim mines As Integer
Dim hldindex As String

'set the index
hldindex = rsSectors.Index
rsSectors.Index = "UpdateOrder"

If Initial Then
    mines = 1
Else
    mines = 0
End If

Harbour = ""

rsSectors.MoveFirst
While Not rsSectors.EOF

    If Initial Or _
        (rsSectors.Fields("x") >= sx1 And rsSectors.Fields("x") <= sx2 And _
        rsSectors.Fields("y") >= sy1 And rsSectors.Fields("y") <= sy2) Then
           
        rsSectors.Edit
        
        '0,0 is a gold mine
        If Initial And rsSectors.Fields("x") = 0 And rsSectors.Fields("y") = 0 Then
            rsSectors.Fields("des") = "g"
            frmEmpCmd.SubmitEmpireCommand "des 0,0 g", False
            frmEmpCmd.SubmitEmpireCommand "thr d 0,0 1", False
        
        '2,0 is a mine
        ElseIf Initial And rsSectors.Fields("x") = 2 And rsSectors.Fields("y") = 0 Then
            rsSectors.Fields("des") = "m"
            frmEmpCmd.SubmitEmpireCommand "des 2,0 m", False
            frmEmpCmd.SubmitEmpireCommand "thr i 2,0 1", False
        
        ElseIf Not Initial And rsSectors.Fields("des") = "h" Then
            Harbour = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
            
        ElseIf Not Initial And rsSectors.Fields("des") = "=" Then
            
        'Dim oil well
        ElseIf rsSectors.Fields("ocontent") > 10 Then
            rsSectors.Fields("des") = "o"
            strSect = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
            frmEmpCmd.SubmitEmpireCommand "des " + strSect + " o", False
            frmEmpCmd.SubmitEmpireCommand "thr o " + strSect + " 1", False
            If rsSectors.Fields("ocontent") > 90 And Oil = "" Then
                Oil = strSect
            End If
        
        'Dim up to 3 mines
        ElseIf rsSectors.Fields("min") > 90 And mines < 3 Then
            rsSectors.Fields("des") = "m"
            strSect = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
            frmEmpCmd.SubmitEmpireCommand "des " + strSect + " m", False
            frmEmpCmd.SubmitEmpireCommand "thr i " + strSect + " 1", False
            mines = mines + 1
            
        'Dim up to several golds
        ElseIf rsSectors.Fields("gold") > 20 Then
            rsSectors.Fields("des") = "g"
            strSect = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
            frmEmpCmd.SubmitEmpireCommand "des " + strSect + " g", False
            frmEmpCmd.SubmitEmpireCommand "thr d " + strSect + " 1", False
        
        'Finally - make it a highway
        Else
            rsSectors.Fields("des") = "+"
            strSect = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
            frmEmpCmd.SubmitEmpireCommand "des " + strSect + " +", False
        End If
        
        rsSectors.Update
    End If
    
    rsSectors.MoveNext
Wend

'capital
Cap = SetOpenHex("c", 0, Initial, sx1, sy1, sx2, sy2)
frmEmpCmd.SubmitEmpireCommand "des " + Cap + " c", False

If Initial Then
    'Reset Capital
    frmEmpCmd.SubmitEmpireCommand "cap " + Cap, False

    'move people to oil well
    frmEmpCmd.SubmitEmpireCommand "move c 0,0 250 " + Oil, False
    
    'build library and move people
    strSect = SetOpenHex("l", 2, Initial, sx1, sy1, sx2, sy2)
    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " l", False
    frmEmpCmd.SubmitEmpireCommand "thr l " + strSect + " 150", False
    frmEmpCmd.SubmitEmpireCommand "move c 2,0 150 " + strSect, False
    
    'build tech center and move people
    strSect = SetOpenHex("t", 2, Initial, sx1, sy1, sx2, sy2)
    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " t", False
    frmEmpCmd.SubmitEmpireCommand "thr l " + strSect + " 120", False
    frmEmpCmd.SubmitEmpireCommand "thr o " + strSect + " 60", False
    frmEmpCmd.SubmitEmpireCommand "thr d " + strSect + " 999", False
    frmEmpCmd.SubmitEmpireCommand "move c 2,0 100 " + strSect, False
End If

'lcm factory
strSect = SetOpenHex("j", 2, Initial, sx1, sy1, sx2, sy2)
frmEmpCmd.SubmitEmpireCommand "des " + strSect + " j", False
frmEmpCmd.SubmitEmpireCommand "thr i " + strSect + " 999", False
frmEmpCmd.SubmitEmpireCommand "thr l " + strSect + " 1", False
frmEmpCmd.SubmitEmpireCommand "move c 0,0 250 " + strSect, False

'harbour
If Len(Harbour) = 0 Then
    Harbour = SetOpenHex("h", 1, Initial, sx1, sy1, sx2, sy2)
    frmEmpCmd.SubmitEmpireCommand "des " + Harbour + " h", False
    If Initial Then
        frmEmpCmd.SubmitEmpireCommand "move c 2,0 300 " + Harbour, False
    End If
End If

'bank
strSect = SetOpenHex("b", 0, Initial, sx1, sy1, sx2, sy2)
frmEmpCmd.SubmitEmpireCommand "des " + strSect + " b", False
frmEmpCmd.SubmitEmpireCommand "thr d " + strSect + " 300", False

'hcm
strSect = SetOpenHex("k", 2, Initial, sx1, sy1, sx2, sy2)
frmEmpCmd.SubmitEmpireCommand "des " + strSect + " k", False
frmEmpCmd.SubmitEmpireCommand "thr i " + strSect + " 999", False
frmEmpCmd.SubmitEmpireCommand "thr h " + strSect + " 1", False

If Not Initial Then
    'enlistment center
    strSect = SetOpenHex("e", 2, Initial, sx1, sy1, sx2, sy2)
    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " e", False
    frmEmpCmd.SubmitEmpireCommand "thr m " + strSect + " 200", False
    
    'another hcm
    strSect = SetOpenHex("k", 2, Initial, sx1, sy1, sx2, sy2)
    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " k", False
    frmEmpCmd.SubmitEmpireCommand "thr i " + strSect + " 999", False
    frmEmpCmd.SubmitEmpireCommand "thr h " + strSect + " 1", False

End If

'distribution
If Initial Then
    strSect = "* "
Else
    strSect = CStr(sx1) + ":" + CStr(sx2) + "," + CStr(sy1) + ":" + CStr(sy2) + " "
End If

frmEmpCmd.SubmitEmpireCommand "dist " + strSect + Harbour, False
frmEmpCmd.SubmitEmpireCommand "thr c " + strSect + "768", False
frmEmpCmd.SubmitEmpireCommand "thr u " + strSect + "868", False

frmEmpCmd.SubmitEmpireCommand "db1", False
frmEmpCmd.SubmitEmpireCommand "dump *", False
frmEmpCmd.SubmitEmpireCommand "db2", False

'restore Index
rsSectors.Index = hldindex
Exit Sub
Empire_Error:
EmpireError "BlitzSetup", "", ""

End Sub


Private Function SetOpenHex(strDes As String, Coast As Integer, _
    Initial As Boolean, sx1 As Integer, sy1 As Integer, sx2 As Integer, sy2 As Integer) As String

'Coast Values
'0 = not on coast
'1 = on coast
'2 = don't care
'3 = don't care - non essential

On Error GoTo Empire_Error
Dim SectString As String
Dim x As Integer

If Coast <= 2 Then
    SectString = "-+gom"
Else
    SectString = "-+"
End If

For x = 1 To Len(SectString)
    If Len(SetOpenHex) = 0 Then
        rsSectors.MoveFirst
        Do
            If Not ((rsSectors.Fields("x") = 0 And rsSectors.Fields("y") = 0) Or _
                (rsSectors.Fields("x") = 2 And rsSectors.Fields("y") = 0)) And _
                rsSectors.Fields("des") = Mid(SectString, x, 1) Then
                
                If Initial Or _
                    (rsSectors.Fields("x") >= sx1 And rsSectors.Fields("x") <= sx2 And _
                    rsSectors.Fields("y") >= sy1 And rsSectors.Fields("y") <= sy2) Then
                    
                    Select Case Coast
                        Case 0
                            If rsSectors.Fields("coast") = 0 Then
                                SetOpenHex = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
                                rsSectors.Edit
                                rsSectors.Fields("des") = strDes
                                rsSectors.Update
                                Exit Do
                            End If
                        Case 1
                            If rsSectors.Fields("coast") = 1 Then
                                SetOpenHex = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
                                rsSectors.Edit
                                rsSectors.Fields("des") = strDes
                                rsSectors.Update
                                Exit Do
                            End If
                        Case 2, 3
                            SetOpenHex = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
                            rsSectors.Edit
                            rsSectors.Fields("des") = strDes
                            rsSectors.Update
                            Exit Do
                    End Select
                End If
            End If
            
            rsSectors.MoveNext
        Loop Until rsSectors.EOF
    End If
Next x
Exit Function
Empire_Error:
EmpireError "SetOpenHex", "", ""

End Function
Public Sub IslandDevelop(sx1 As Integer, sy1 As Integer, sx2 As Integer, sy2 As Integer)
On Error GoTo Empire_Error

Dim strSect As String
Dim Cap As String
Dim Harbour As String
Dim Oil As String
Dim x As Integer
Dim mines As Integer
Dim hldindex As String

'set the index
hldindex = rsSectors.Index
rsSectors.Index = "UpdateOrder"

mines = 0
Harbour = ""

'Pass one - redesignate old mines to highways
rsSectors.MoveFirst
While Not rsSectors.EOF

    If (rsSectors.Fields("x") >= sx1 And rsSectors.Fields("x") <= sx2 And _
        rsSectors.Fields("y") >= sy1 And rsSectors.Fields("y") <= sy2) Then
           
        rsSectors.Edit
        
        Select Case rsSectors.Fields("des")
            Case "g"
                If rsSectors.Fields("gold") = 0 Then
                    rsSectors.Fields("des") = "+"
                    strSect = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
                    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " +", False
                End If
            Case "o"
                If rsSectors.Fields("ocontent") < 5 Then
                    rsSectors.Fields("des") = "+"
                    strSect = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
                    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " +", False
                End If
            Case "m"
                If rsSectors.Fields("gold") > 0 Then
                    rsSectors.Fields("des") = "g"
                    strSect = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
                    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " g", False
                    frmEmpCmd.SubmitEmpireCommand "thr d " + strSect + " 1", False
                Else
                    mines = mines + 1
                End If
            End Select
        
        rsSectors.Update
    End If
    
    rsSectors.MoveNext
Wend

'Pass two - designate new oilwells and mines
rsSectors.MoveFirst
While Not rsSectors.EOF

    If (rsSectors.Fields("x") >= sx1 And rsSectors.Fields("x") <= sx2 And _
        rsSectors.Fields("y") >= sy1 And rsSectors.Fields("y") <= sy2) And _
        rsSectors.Fields("des") = "+" Then
           
        rsSectors.Edit
        
        If rsSectors.Fields("gold") > 0 Then
            rsSectors.Fields("des") = "g"
            strSect = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
            frmEmpCmd.SubmitEmpireCommand "des " + strSect + " g", False
            frmEmpCmd.SubmitEmpireCommand "thr d " + strSect + " 1", False
        ElseIf rsSectors.Fields("oil") > 5 Then
            rsSectors.Fields("des") = "o"
            strSect = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
            frmEmpCmd.SubmitEmpireCommand "des " + strSect + " o", False
            frmEmpCmd.SubmitEmpireCommand "thr o " + strSect + " 1", False
        ElseIf rsSectors.Fields("min") > 80 And mines < 4 Then
            mines = mines + 1
            rsSectors.Fields("des") = "m"
            strSect = SectorString(rsSectors.Fields("x"), rsSectors.Fields("y"))
            frmEmpCmd.SubmitEmpireCommand "des " + strSect + " m", False
            frmEmpCmd.SubmitEmpireCommand "thr i " + strSect + " 1", False
        End If
        
        rsSectors.Update
    End If
    
    rsSectors.MoveNext
Wend

'build airport
strSect = SetOpenHex("*", 0, False, sx1, sy1, sx2, sy2)
frmEmpCmd.SubmitEmpireCommand "des " + strSect + " *", False
frmEmpCmd.SubmitEmpireCommand "thr l " + strSect + " 300", False
frmEmpCmd.SubmitEmpireCommand "thr h " + strSect + " 150", False
frmEmpCmd.SubmitEmpireCommand "thr s " + strSect + " 100", False
frmEmpCmd.SubmitEmpireCommand "thr m " + strSect + " 200", False
frmEmpCmd.SubmitEmpireCommand "thr p " + strSect + " 800", False
    
'build fortress
strSect = SetOpenHex("f", 1, False, sx1, sy1, sx2, sy2)
frmEmpCmd.SubmitEmpireCommand "des " + strSect + " f", False
frmEmpCmd.SubmitEmpireCommand "thr m " + strSect + " 200", False
frmEmpCmd.SubmitEmpireCommand "thr h " + strSect + " 100", False
frmEmpCmd.SubmitEmpireCommand "thr s " + strSect + " 50", False
frmEmpCmd.SubmitEmpireCommand "thr g " + strSect + " 10", False
    
'build shell factory
strSect = SetOpenHex("i", 2, False, sx1, sy1, sx2, sy2)
frmEmpCmd.SubmitEmpireCommand "des " + strSect + " i", False
frmEmpCmd.SubmitEmpireCommand "thr l " + strSect + " 200", False
frmEmpCmd.SubmitEmpireCommand "thr h " + strSect + " 100", False
frmEmpCmd.SubmitEmpireCommand "thr s " + strSect + " 1", False
    
'build defense plant
strSect = SetOpenHex("d", 2, False, sx1, sy1, sx2, sy2)
frmEmpCmd.SubmitEmpireCommand "des " + strSect + " d", False
frmEmpCmd.SubmitEmpireCommand "thr l " + strSect + " 100", False
frmEmpCmd.SubmitEmpireCommand "thr o " + strSect + " 20", False
frmEmpCmd.SubmitEmpireCommand "thr h " + strSect + " 200", False
frmEmpCmd.SubmitEmpireCommand "thr g " + strSect + " 1", False

'headquarters
strSect = SetOpenHex("!", 2, False, sx1, sy1, sx2, sy2)
frmEmpCmd.SubmitEmpireCommand "des " + strSect + " !", False
frmEmpCmd.SubmitEmpireCommand "thr l " + strSect + " 300", False
frmEmpCmd.SubmitEmpireCommand "thr h " + strSect + " 150", False
frmEmpCmd.SubmitEmpireCommand "thr s " + strSect + " 100", False
frmEmpCmd.SubmitEmpireCommand "thr g " + strSect + " 20", False
frmEmpCmd.SubmitEmpireCommand "thr m " + strSect + " 200", False

'refinery
strSect = SetOpenHex("%", 2, False, sx1, sy1, sx2, sy2)
frmEmpCmd.SubmitEmpireCommand "des " + strSect + " %", False
frmEmpCmd.SubmitEmpireCommand "thr p " + strSect + " 1", False
frmEmpCmd.SubmitEmpireCommand "thr o " + strSect + " 20", False

'hcm
strSect = SetOpenHex("k", 3, False, sx1, sy1, sx2, sy2)
If Len(strSect) > 0 Then
    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " k", False
    frmEmpCmd.SubmitEmpireCommand "thr i " + strSect + " 999", False
    frmEmpCmd.SubmitEmpireCommand "thr h " + strSect + " 1", False
End If

'lcm factory
If Len(strSect) > 0 Then
    strSect = SetOpenHex("j", 3, False, sx1, sy1, sx2, sy2)
    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " j", False
    frmEmpCmd.SubmitEmpireCommand "thr i " + strSect + " 999", False
    frmEmpCmd.SubmitEmpireCommand "thr l " + strSect + " 1", False
End If

'build fortress
If Len(strSect) > 0 Then
    strSect = SetOpenHex("f", 3, False, sx1, sy1, sx2, sy2)
    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " f", False
    frmEmpCmd.SubmitEmpireCommand "thr m " + strSect + " 200", False
    frmEmpCmd.SubmitEmpireCommand "thr h " + strSect + " 100", False
    frmEmpCmd.SubmitEmpireCommand "thr s " + strSect + " 50", False
    frmEmpCmd.SubmitEmpireCommand "thr g " + strSect + " 10", False
End If
    
'enlistment center
If Len(strSect) > 0 Then
    strSect = SetOpenHex("e", 3, False, sx1, sy1, sx2, sy2)
    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " e", False
    frmEmpCmd.SubmitEmpireCommand "thr m " + strSect + " 118", False
End If
    
'build fortress
If Len(strSect) > 0 Then
    strSect = SetOpenHex("f", 3, False, sx1, sy1, sx2, sy2)
    frmEmpCmd.SubmitEmpireCommand "des " + strSect + " f", False
    frmEmpCmd.SubmitEmpireCommand "thr m " + strSect + " 200", False
    frmEmpCmd.SubmitEmpireCommand "thr h " + strSect + " 100", False
    frmEmpCmd.SubmitEmpireCommand "thr s " + strSect + " 50", False
    frmEmpCmd.SubmitEmpireCommand "thr g " + strSect + " 10", False
End If
    
frmEmpCmd.SubmitEmpireCommand "db1", False
frmEmpCmd.SubmitEmpireCommand "dump *", False
frmEmpCmd.SubmitEmpireCommand "db2", False

'restore Index
rsSectors.Index = hldindex
Exit Sub
Empire_Error:
EmpireError "IslandDevelop", "", ""

End Sub
       

Public Sub AddEnemySectInfo(varInfo As Variant)

'Information is in the variant designation

Dim n As Integer
Dim sx As Integer
Dim sy As Integer

'if you are not getting an array, then quit
If Not IsArray(varInfo) Then
    Exit Sub
End If

On Error GoTo AddEnemySectInfo_Exit

n = ES_X
sx = varInfo(ES_X)
n = ES_Y
sy = varInfo(ES_Y)

'Find out if we already have the record
rsEnemySect.Seek "=", sx, sy
If rsEnemySect.NoMatch Then
    rsEnemySect.AddNew
Else
    rsEnemySect.Edit
End If
    
'Setup the bmap record also
rsBmap.Seek "=", sx, sy
If rsBmap.NoMatch Then
    rsBmap.AddNew
    rsBmap.Fields("x") = sx
    rsBmap.Fields("y") = sy
Else
    rsBmap.Edit
End If
    
For n = 1 To UBound(varInfo)

    If varInfo(n) = "???" Then
        varInfo(n) = "-1"
    End If
    
    'Put things in the right fields
    Select Case n
        Case ES_DES
            rsEnemySect.Fields("des") = Left(varInfo(n), 1)
            rsBmap.Fields("des").Value = Left(varInfo(n), 1)
            rsBmap.Update
        Case ES_X
            rsEnemySect.Fields("x") = CInt(varInfo(n))
        Case ES_Y
            rsEnemySect.Fields("y") = CInt(varInfo(n))
        Case ES_OWNER
            rsEnemySect.Fields("owner") = CInt(varInfo(n))
        Case ES_OLDOWNER
            rsEnemySect.Fields("oldowner") = CInt(varInfo(n))
        Case ES_EFFICIENCY
            rsEnemySect.Fields("eff") = CInt(varInfo(n))
        Case ES_ROAD
            rsEnemySect.Fields("road") = CInt(varInfo(n))
        Case ES_RAIL
            rsEnemySect.Fields("rail") = CInt(varInfo(n))
        Case ES_DEFENSE
            rsEnemySect.Fields("defense") = CInt(varInfo(n))
        Case ES_CIV
            rsEnemySect.Fields("civ") = CInt(varInfo(n))
        Case ES_MIL
            rsEnemySect.Fields("mil") = CInt(varInfo(n))
        Case ES_SHELL
            rsEnemySect.Fields("shell") = CInt(varInfo(n))
        Case ES_GUN
            rsEnemySect.Fields("gun") = CInt(varInfo(n))
        Case ES_PETROL
            rsEnemySect.Fields("pet") = CInt(varInfo(n))
        Case ES_FOOD
            rsEnemySect.Fields("food") = CInt(varInfo(n))
        Case ES_BARS
            rsEnemySect.Fields("bar") = CInt(varInfo(n))
        Case ES_IRON
            rsEnemySect.Fields("iron") = CInt(varInfo(n))
    End Select
    
Next n
rsEnemySect.Fields("timestamp") = Format(Now, "ddd mmm dd hh:mm:ss yyyy")
rsEnemySect.Update


Exit Sub

'Error handling routine
AddEnemySectInfo_Exit:
Dim var As String
Dim strLine As String
var = CStr(n)
For n = 1 To UBound(varInfo)
    strLine = strLine + CStr(varInfo(n)) + ","
Next n
EmpireError "AddEnemySectInfo", var, strLine
End Sub


Public Sub AddEnemyUnitInfo(varInfo As Variant)

'Information is in the variant designation

Dim n As Integer
Dim sowner As Integer
Dim stype As String
Dim sclass As String
Dim sid As Integer
Dim s1 As String
Dim s2 As String
Dim s3 As String
Dim swake As String

'if you are not getting an array, then quit
If Not IsArray(varInfo) Then
    Exit Sub
End If

On Error GoTo AddEnemyUnitInfo_Exit

n = EU_OWNER
sowner = CInt(varInfo(EU_OWNER))
n = EU_ID
sid = CInt(varInfo(EU_ID))
n = EU_TYPE
stype = varInfo(EU_TYPE)

'get the class
sclass = CStr(varInfo(0))

'Find out if we already have the record
rsEnemyUnit.Index = "PrimaryKey"
rsEnemyUnit.Seek "=", sowner, sclass, sid
If rsEnemyUnit.NoMatch Then
    rsEnemyUnit.AddNew
    swake = ""
Else
    rsEnemyUnit.Edit
    'for ships, keep a "wake" that shows where they have been
    swake = rsEnemyUnit.Fields("wake")
    If sclass = "s" Then
        If varInfo(EU_X) <> rsEnemyUnit.Fields("x") Or _
           varInfo(EU_Y) <> rsEnemyUnit.Fields("y") Then
            If ((rsEnemyUnit.Fields("x") + rsEnemyUnit.Fields("y")) Mod 2) = 0 Then
                If Right(swake, 1) <> ";" Then  'clear wake from earlier versions
                    swake = ""
                End If
                swake = swake + SectorString(rsEnemyUnit.Fields("x"), _
                    rsEnemyUnit.Fields("y")) + ";"
                While Len(swake) > 50
                    n = InStr(swake, ";")
                    swake = Mid(swake, n + 1)
                Wend
            End If
        End If
    End If
    
End If
    
'record class
rsEnemyUnit.Fields("class") = sclass

For n = 1 To UBound(varInfo)

    If varInfo(n) = "???" Then
        varInfo(n) = "-1"
    End If
    
    'Put things in the right fields
    Select Case n
        Case EU_ID
            rsEnemyUnit.Fields("id") = sid
        Case EU_X
            rsEnemyUnit.Fields("x") = CInt(varInfo(n))
        Case EU_Y
            rsEnemyUnit.Fields("y") = CInt(varInfo(n))
        Case EU_OWNER
            rsEnemyUnit.Fields("owner") = sowner
        Case EU_TYPE
            rsEnemyUnit.Fields("type") = varInfo(n)
        Case EU_MIL
            rsEnemyUnit.Fields("mil") = CInt(varInfo(n))
        Case EU_TECH
            rsEnemyUnit.Fields("tech") = CInt(varInfo(n))
        Case EU_EFF
            rsEnemyUnit.Fields("eff") = CInt(varInfo(n))
            
    End Select
    
Next n
rsEnemyUnit.Fields("wake") = swake
rsEnemyUnit.Fields("timestamp") = Format(Now, "ddd mmm dd hh:mm:ss yyyy")

rsEnemyUnit.Update
Exit Sub

'Error handling routine
AddEnemyUnitInfo_Exit:
Dim var As String
Dim strLine As String
var = CStr(n)
For n = 1 To UBound(varInfo)
    strLine = strLine + CStr(varInfo(n)) + ","
Next n

EmpireError "AddEnemyUnitInfo", var, strLine

End Sub


Public Function ClearEnemyInfo(Optional Sure As Variant) As Boolean
On Error GoTo Empire_Error

Dim MsgReply As Integer

If IsMissing(Sure) Then
    Sure = False
End If

'if there is no enemy information, then exit
If (rsEnemyUnit.BOF And rsEnemyUnit.EOF) And (rsEnemySect.BOF And rsEnemySect.EOF) And (rsAirCombat.BOF And rsAirCombat.EOF) Then
    Exit Function
End If

'If not sure, then confirm
If Not Sure Then
    MsgReply = MsgBox("Are you sure you want to clear all Enemy Intelligence", vbQuestion + vbOKCancel, "Clear Intelligence Comfirmation")
    If MsgReply = vbCancel Then
        ClearEnemyInfo = False
        Exit Function
    End If
End If

If Not (rsEnemyUnit.BOF And rsEnemyUnit.EOF) Then
    rsEnemyUnit.MoveFirst
    While Not (rsEnemyUnit.BOF And rsEnemyUnit.EOF)
        rsEnemyUnit.Delete
        rsEnemyUnit.MoveFirst
    Wend
End If

If Not (rsEnemySect.BOF And rsEnemySect.EOF) Then
    rsEnemySect.MoveFirst
    While Not (rsEnemySect.BOF And rsEnemySect.EOF)
        rsEnemySect.Delete
        rsEnemySect.MoveFirst
    Wend
End If

If Not (rsAirCombat.BOF And rsAirCombat.EOF) Then
    rsAirCombat.MoveFirst
    While Not (rsAirCombat.BOF And rsAirCombat.EOF)
        rsAirCombat.Delete
        rsAirCombat.MoveFirst
    Wend
End If

ClearEnemyInfo = True
Exit Function
Empire_Error:
EmpireError "ClearEnemyInfo", "", ""
End Function

Public Sub UpdateLights()
On Error GoTo Empire_Error
'set the green and red lights in the main window status bar
If frmEmpCmd.CmdinProgress Or Not frmEmpCmd.ConnectedtoHost Then
    Set frmDrawMap.sb1.Panels.Item("Lights").Picture = picRedLight
    frmDrawMap.sb1.Panels.Item("Lights").ToolTipText = "Empire Server Unavailable"
    Set frmEmpCmd.imgLights.Picture = picRedLight
Else
    Set frmDrawMap.sb1.Panels.Item("Lights").Picture = picGreenLight
    frmDrawMap.sb1.Panels.Item("Lights").ToolTipText = "Empire Server Available"
    Set frmEmpCmd.imgLights.Picture = picGreenLight
End If
Exit Sub
Empire_Error:
EmpireError "UpdateLights", "", ""
End Sub

Public Sub SetOwner(sx1 As Integer, sy1 As Integer, sx2 As Integer, sy2 As Integer, Nation As Integer)
On Error GoTo Empire_Error

Dim hldindex

'set the index
hldindex = rsBmap.Index
rsBmap.Index = "PrimaryKey"

rsBmap.MoveFirst
While Not rsBmap.EOF

    If (rsBmap.Fields("x") >= sx1 And rsBmap.Fields("x") <= sx2 And _
        rsBmap.Fields("y") >= sy1 And rsBmap.Fields("y") <= sy2) Then
        rsEnemySect.Seek "=", rsBmap.Fields("x"), rsBmap.Fields("y")
        If rsBmap.Fields("des") <> "." And rsBmap.Fields("des") <> "X" Then
            If rsEnemySect.NoMatch Then
                rsEnemySect.AddNew
                rsEnemySect.Fields("x") = rsBmap.Fields("x")
                rsEnemySect.Fields("y") = rsBmap.Fields("y")
                rsEnemySect.Fields("oldowner") = 0
                rsEnemySect.Fields("eff") = 0
                rsEnemySect.Fields("road") = 0
                rsEnemySect.Fields("rail") = 0
                rsEnemySect.Fields("defense") = 0
                rsEnemySect.Fields("civ") = 0
                rsEnemySect.Fields("mil") = 0
                rsEnemySect.Fields("shell") = 0
                rsEnemySect.Fields("gun") = 0
                rsEnemySect.Fields("pet") = 0
                rsEnemySect.Fields("food") = 0
                rsEnemySect.Fields("bar") = 0
                rsEnemySect.Fields("iron") = 0
                rsEnemySect.Fields("timestamp") = Format(Now, "ddd mmm dd, hh:mm")
            Else
                rsEnemySect.Edit
            End If
            rsEnemySect.Fields("owner") = Nation
            rsEnemySect.Fields("des") = rsBmap.Fields("des")
            
            rsEnemySect.Update
        End If
    End If
    
    rsBmap.MoveNext
Wend


'restore Index
rsBmap.Index = hldindex
frmDrawMap.DrawHexes
Exit Sub
Empire_Error:
EmpireError "SetOwner", "", ""
End Sub

Public Sub ExportIntelligence()
On Error GoTo Empire_Error

Dim filenumber As Integer
Dim n As Integer
Dim nsect As Integer
Dim nunit As Integer
Dim FileName As String

'update the timestamp if it is still in version 1.1 format
If Not (rsEnemySect.BOF And rsEnemySect.EOF) Then
    rsEnemySect.MoveFirst
    While Not rsEnemySect.EOF
        If InStr(rsEnemySect.Fields("timestamp"), ",") > 0 Then
            rsEnemySect.Edit
            n = InStr(rsEnemySect.Fields("timestamp"), ",")
            rsEnemySect.Fields("timestamp") = Left(rsEnemySect.Fields("timestamp"), n - 1) _
                + Mid(rsEnemySect.Fields("timestamp"), n + 1) + ":00 1998"
            rsEnemySect.Update
        End If
        rsEnemySect.MoveNext
    Wend
End If

'update the timestamp if it is still in version 1.1 format
If Not (rsEnemyUnit.BOF And rsEnemyUnit.EOF) Then
    rsEnemyUnit.MoveFirst
    While Not rsEnemyUnit.EOF
        If InStr(rsEnemyUnit.Fields("timestamp"), ",") > 0 Then
            rsEnemyUnit.Edit
            n = InStr(rsEnemyUnit.Fields("timestamp"), ",")
            rsEnemyUnit.Fields("timestamp") = Left(rsEnemyUnit.Fields("timestamp"), n - 1) _
                + Mid(rsEnemyUnit.Fields("timestamp"), n + 1) + ":00 1998"
            rsEnemyUnit.Update
        End If
        rsEnemyUnit.MoveNext
    Wend
End If

FileName = App.Path + "\" + GameName + " Intelligence.txt"
filenumber = FreeFile   ' Get unused file number.
Open FileName For Output As #filenumber

'now write out the sector file
If Not (rsEnemySect.BOF And rsEnemySect.EOF) Then
    rsEnemySect.MoveFirst
    While Not rsEnemySect.EOF
        nsect = nsect + 1
        For n = 0 To rsEnemySect.Fields.Count - 2
            Write #filenumber, rsEnemySect.Fields(n);
        Next n
        Write #filenumber, rsEnemySect.Fields(rsEnemySect.Fields.Count - 1)
        rsEnemySect.MoveNext
    Wend
    rsEnemySect.MoveLast
End If
Write #filenumber, "+++ " + CStr(nsect) + " Sectors exported"

'now write out the unit file
If Not (rsEnemyUnit.BOF And rsEnemyUnit.EOF) Then
    rsEnemyUnit.MoveFirst
    While Not rsEnemyUnit.EOF
        nunit = nunit + 1
        For n = 0 To rsEnemyUnit.Fields.Count - 2
            Write #filenumber, rsEnemyUnit.Fields(n);
        Next n
        Write #filenumber, rsEnemyUnit.Fields(rsEnemyUnit.Fields.Count - 1)
        rsEnemyUnit.MoveNext
    Wend
    rsEnemySect.MoveLast
End If
Write #filenumber, "+++ " + CStr(nunit) + " Units exported"
Close #filenumber

MsgBox CStr(nsect) + " Sectors, " + CStr(nunit) + " Units exported to file " + FileName
Exit Sub
Empire_Error:
EmpireError "ExportIntelligence", "", ""
End Sub

Public Sub ImportIntelligence()
On Error GoTo Empire_Error

Dim filenumber As Integer
Dim n As Integer
Dim nsect As Integer
Dim nsect2 As Integer
Dim nunit As Integer
Dim nunit2 As Integer
Dim FileName As String
Dim OnSectors As Boolean
Dim x As Variant
Dim Y As Variant
Dim hldvar As Variant
Dim temp() As Variant
Dim rs As Recordset
Dim count1 As Integer
Dim count2 As Integer
Dim date1 As Date
Dim date2 As Date
Dim hldindex

hldindex = rsEnemyUnit.Index

'update the timestamp if it is still in version 1.1 format
If Not (rsEnemySect.BOF And rsEnemySect.EOF) Then
    rsEnemySect.MoveFirst
    While Not rsEnemySect.EOF
        If InStr(rsEnemySect.Fields("timestamp"), ",") > 0 Then
            rsEnemySect.Edit
            n = InStr(rsEnemySect.Fields("timestamp"), ",")
            rsEnemySect.Fields("timestamp") = Left(rsEnemySect.Fields("timestamp"), n - 1) _
                + Mid(rsEnemySect.Fields("timestamp"), n + 1) + ":00 1998"
            rsEnemySect.Update
        End If
        rsEnemySect.MoveNext
    Wend
End If

'update the timestamp if it is still in version 1.1 format
If Not (rsEnemyUnit.BOF And rsEnemyUnit.EOF) Then
    rsEnemyUnit.MoveFirst
    While Not rsEnemyUnit.EOF
        If InStr(rsEnemyUnit.Fields("timestamp"), ",") > 0 Then
            rsEnemyUnit.Edit
            n = InStr(rsEnemyUnit.Fields("timestamp"), ",")
            rsEnemyUnit.Fields("timestamp") = Left(rsEnemyUnit.Fields("timestamp"), n - 1) _
                + Mid(rsEnemyUnit.Fields("timestamp"), n + 1) + ":00 1998"
            rsEnemyUnit.Update
        End If
        rsEnemyUnit.MoveNext
    Wend
End If

ChDir App.Path

Load frmCommonDialog
' Set CancelError is True
frmCommonDialog.cdb.CancelError = True
' Set flags
frmCommonDialog.cdb.FLAGS = cdlOFNHideReadOnly
' Set filters
frmCommonDialog.cdb.Filter = "All Files (*.*)|*.*|Text Files" & _
"(*.txt)|*.txt"
' Specify default filter
frmCommonDialog.cdb.FilterIndex = 2
' Display name of selected file
frmCommonDialog.cdb.FileName = ""

' Display the open dialog box
frmCommonDialog.cdb.ShowOpen

FileName = frmCommonDialog.cdb.FileName
filenumber = FreeFile   ' Get unused file number.
Open FileName For Input As #filenumber

rsEnemyUnit.Index = "PrimaryKey"
OnSectors = True
Set rs = rsEnemySect
count1 = 0
count2 = 0
'first input the sector file
While Not EOF(filenumber)
    Input #filenumber, x
    If Left(x, 3) = "+++" Then
        If OnSectors Then
            OnSectors = False
            Set rs = rsEnemyUnit
            nsect = count1
            nsect2 = count2
            count1 = 0
            count2 = 0
        End If
    Else
        ReDim temp(0 To rs.Fields.Count - 1)
        temp(0) = x
        For n = 1 To rs.Fields.Count - 1
            Input #filenumber, temp(n)
        Next n
        count1 = count1 + 1
        If OnSectors Then
            rs.Seek "=", CInt(temp(0)), CInt(temp(1))
        Else
            rs.Seek "=", CInt(temp(4)), CStr(temp(9)), CInt(temp(0))
        End If
        If rs.NoMatch Then
            rs.AddNew
            For n = 0 To rs.Fields.Count - 1
                rs.Fields(n) = temp(n)
            Next n
            rs.Update
            count2 = count2 + 1
        Else
            
            'decide which is more recent
            date1 = EmpireTimeString(rs.Fields("timestamp").Value)
        If OnSectors Then
            date2 = EmpireTimeString(CStr(temp(17)))
        Else
            date2 = EmpireTimeString(CStr(temp(8)))
        End If
            If date1 < date2 Then
                
                'if export is more recent, use it
                rs.Edit
                For n = 0 To rs.Fields.Count - 1
                    rs.Fields(n) = temp(n)
                Next n
                
                rs.Update
                count2 = count2 + 1
            End If
        End If
    End If
Wend
nunit = count1
nunit2 = count2

Close #filenumber

MsgBox CStr(nsect) + " Sectors read, " + CStr(nsect2) + " Sectors updated, " _
    + CStr(nunit) + " Units read, " + CStr(nunit2) + " Units updated."

rsEnemyUnit.Index = hldindex

Exit Sub
Empire_Error:
EmpireError "ImportIntelligence", "", ""
rsEnemyUnit.Index = hldindex

End Sub

Public Sub OffsetSectorLocation(ByRef sx As Integer, ByRef sy As Integer, offx As Integer, offy As Integer)
On Error GoTo Empire_Error

Dim MaxX As Integer
Dim MaxY As Integer

sx = sx + offx
sy = sy + offy

'Adjust x for world wrap
MaxX = rsVersion.Fields("World X") / 2
MaxY = rsVersion.Fields("World Y") / 2

While sx > MaxX
    sx = sx - rsVersion.Fields("World X")
Wend

While sx < (-1 * MaxX)
    sx = sx + rsVersion.Fields("World X")
Wend

While sy > MaxY
    sy = sy - rsVersion.Fields("World Y")
Wend

While sy < (-1 * MaxY)
    sy = sy + rsVersion.Fields("World Y")
Wend
Exit Sub
Empire_Error:
EmpireError "OffsetSectorLocation", "", ""
End Sub

Public Sub ExploreOut(strSect As String, strUnit As String, radius As Integer, Occur As Integer, OldSectorCount As Integer)

Dim range(0 To MaxExploreRadius * 4 + 5, 0 To MaxExploreRadius * 2 + 3) As Integer
Dim paths(0 To MaxExploreRadius * 4 + 5, 0 To MaxExploreRadius * 2 + 3) As String
Dim p1 As Integer
Dim Startx As Integer
Dim StartY As Integer
Dim x As Integer
Dim Y As Integer
Dim n As Integer
Dim offy As Integer
Dim offx As Integer
Dim holdy As Integer
Dim holdx As Integer
Dim strCmd As String
Dim Done As Boolean
Dim found As Boolean
Dim newsector As Boolean
Dim unknown As Boolean
Dim UnitsAvail As Integer
Dim NewSectorCount As Integer

Const OWNED_SECTOR = 2
Const CHECK_SECTOR = 1
Const EXPLORATION_SECTOR = 3
Const UNPASSABLE_SECTOR = 4
On Error Resume Next

'verify sector and set offsets
If ParseSectors(Startx, StartY, strSect) Then
    offx = Startx - (MaxExploreRadius + 2) * 2
    offy = StartY - MaxExploreRadius
Else
    Exit Sub
End If

UnitsAvail = 0

'if the sector count is the same as the last time, you are done
NewSectorCount = rsSectors.RecordCount
If Occur > 1 And NewSectorCount = OldSectorCount Then
    Exit Sub
End If

rsSectors.Seek "=", Startx, StartY
If rsSectors.NoMatch Then
    Exit Sub
Else
    If strUnit = "c" Then
        If rsSectors.Fields("mil") > 0 Then
            UnitsAvail = rsSectors.Fields("civ")
        Else
            UnitsAvail = rsSectors.Fields("civ") - 1
        End If
    Else
        If rsSectors.Fields("civ") > 0 And _
            Not (rsSectors.Fields("*").Value = "*") Then
            UnitsAvail = rsSectors.Fields("mil")
        Else
            UnitsAvail = rsSectors.Fields("mil") - 1
        End If
    End If
End If

'Build Starting Point
If radius > MaxExploreRadius Then
    radius = MaxExploreRadius
End If

Done = False
range((MaxExploreRadius + 2) * 2, MaxExploreRadius) = CHECK_SECTOR
unknown = False

'Keep going thru the grids until you have explored all
While Not Done
    Done = True
    For Y = 0 To UBound(paths, 2)
        For p1 = 0 To UBound(paths, 1) Step 2
            x = p1 + (Y Mod 2)
            If range(x, Y) = CHECK_SECTOR Then
                holdx = x + offx
                holdy = Y + offy
                OffsetSectorLocation holdx, holdy, 0, 0
                rsSectors.Seek "=", holdx, holdy
                If rsSectors.NoMatch Then
                    rsBmap.Seek "=", holdx, holdy
                    If rsBmap.NoMatch Then
                        range(x, Y) = UNPASSABLE_SECTOR
                        unknown = True
                    Else
                        ' don't go into water, unknown, wasteland, mountains, or sanctuaries
                        If InStr(".?\/^s", rsBmap.Fields("des")) > 0 Then
                            range(x, Y) = UNPASSABLE_SECTOR
                        Else
                            range(x, Y) = EXPLORATION_SECTOR
                        End If
                    End If
                Else
                   'owned Sector
                    range(x, Y) = OWNED_SECTOR
                End If
                
                If Len(paths(x, Y)) < radius And range(x, Y) <> UNPASSABLE_SECTOR Then
                    If range(x - 2, Y) = 0 Then
                        paths(x - 2, Y) = paths(x, Y) + "g"
                        range(x - 2, Y) = CHECK_SECTOR
                        Done = False
                    End If
                    If range(x - 1, Y - 1) = 0 Then
                        paths(x - 1, Y - 1) = paths(x, Y) + "y"
                        range(x - 1, Y - 1) = CHECK_SECTOR
                        Done = False
                    End If
                    If range(x + 1, Y - 1) = 0 Then
                        paths(x + 1, Y - 1) = paths(x, Y) + "u"
                        range(x + 1, Y - 1) = CHECK_SECTOR
                        Done = False
                    End If
                    If range(x + 2, Y) = 0 Then
                        paths(x + 2, Y) = paths(x, Y) + "j"
                        range(x + 2, Y) = CHECK_SECTOR
                        Done = False
                    End If
                    If range(x + 1, Y + 1) = 0 Then
                        paths(x + 1, Y + 1) = paths(x, Y) + "n"
                        range(x + 1, Y + 1) = CHECK_SECTOR
                        Done = False
                    End If
                    If range(x - 1, Y + 1) = 0 Then
                        paths(x - 1, Y + 1) = paths(x, Y) + "b"
                        range(x - 1, Y + 1) = CHECK_SECTOR
                        Done = False
                    End If
                End If
            End If
        Next p1
    Next Y
Wend

'Now build all the exploration command to the explorable sectors
strCmd = "explore " + strUnit + " " + strSect + " " + "1" + " "

newsector = False
frmEmpCmd.SubmitEmpireCommand "ex1", False
For n = 1 To radius
    found = False
    For Y = 0 To UBound(range, 2)
        For p1 = 0 To UBound(range, 1) - 1 Step 2
            x = p1 + (Y Mod 2)
            If range(x, Y) = EXPLORATION_SECTOR And Len(paths(x, Y)) = n And UnitsAvail > 0 Then
                frmEmpCmd.SubmitEmpireCommand strCmd + paths(x, Y) + "h", True
                UnitsAvail = UnitsAvail - 1
                found = True
            End If
        Next p1
    Next Y
    If found Then
        frmEmpCmd.SubmitEmpireCommand "des * ?des=- +", True
        newsector = True
    End If
Next n

If unknown And newsector And Occur < MaxExploreRadius Then
    frmEmpCmd.SubmitEmpireCommand "ex2", False
Else
    frmEmpCmd.SubmitEmpireCommand "ex4", False
End If

frmEmpCmd.SubmitEmpireCommand "db1", False
frmEmpCmd.SubmitEmpireCommand "dump * ?timestamp>" + CStr(tsSectors), False
frmEmpCmd.SubmitEmpireCommand "map *", False
frmEmpCmd.SubmitEmpireCommand "bmap *", False
frmEmpCmd.SubmitEmpireCommand "db2", False

If unknown And newsector And Occur < MaxExploreRadius Then
    'the ex3 command will cause the explore out to continue to loop
    frmEmpCmd.SubmitEmpireCommand "ex3  " + strSect + ":" + strUnit + ":" _
        + CStr(radius) + ":" + CStr(Occur + 1) + ":" + CStr(NewSectorCount) + ":", False
End If

End Sub

Public Function PadString(str As String, slen As Integer, Optional InFront As Boolean = True)
On Error GoTo Empire_Error
Dim strSpaces As String
Dim strPad As String
On Error Resume Next
strSpaces = "              "
While Len(strSpaces) < slen
    strSpaces = strSpaces + strSpaces
Wend

If Len(str) < slen Then
    strPad = Left(strSpaces, slen - Len(str))
    If InFront Then
        PadString = strPad + str
    Else
        PadString = str + strPad
    End If
Else
    PadString = Left(str, slen)
End If
Exit Function
Empire_Error:
EmpireError "PadString", "", str
End Function

Public Sub ProdSummaryReport(sx1 As Integer, sy1 As Integer, ShowStarve As Boolean, ShowOvrPop As Boolean, ShowIdle As Boolean, ShowBuild As Boolean)
On Error GoTo Empire_Error

Const PR_ITEM = 1
Const PR_ONHAND = 2
Const PR_MADE = 3
Const PR_USED = 4
Const PR_RQST = 5
Const PR_CATG_LAST = 6

Const PR_FOOD = 1
Const PR_IRON = 2
Const PR_LCM = 3
Const PR_HCM = 4
Const PR_DUST = 5
Const PR_BAR = 6
Const PR_GUN = 7
Const PR_SHELL = 8
Const PR_OIL = 9
Const PR_PET = 10
Const PR_MIL = 11
Const PR_RAD = 12
Const PR_CIV = 13
Const PR_UW = 14
Const PR_HAPPY = 15
Const PR_GRAD = 16
Const PR_TECH = 17
Const PR_RESCH = 18
Const PR_SHIP = 19
Const PR_PLANE = 20
Const PR_ARMY = 21
Const PR_CITY = 22
Const PR_FORT = 23
Const PR_COMM_LAST = 23
Const PR_COMM_ITEM = 14
Const PR_MSGC = 10

Dim ar(1 To PR_COMM_LAST, 1 To PR_CATG_LAST) As Variant
Dim sc(1 To PR_COMM_ITEM, 1 To PR_CATG_LAST) As Long
Dim ut(1 To PR_COMM_ITEM, 0 To PR_COMM_LAST) As Long
Dim cp(1 To PR_MSGC) As New Collection
Dim n As Long
Dim n2 As Long
Dim strLine As String
Dim varLine As Variant
Dim v As Variant
Dim strSect As String
Dim strSectHeader As String
Dim strCapt As String
Dim MaxEffGain As Integer
Dim effgain As Single
Dim neweff As Integer
Dim BuildType As String
Dim Target As Integer
Dim LastItem As Integer
Dim rs As Recordset

Dim Costs(1 To 7, 1 To 5) As Single
Dim CostDesc(1 To 5) As String

'Costs array
'First Dim
'1) holds full cost
'2) holds non rounded cost for current unit
'3) holds rounded (integer) cost for current unit)
'4) holds cumulative remander (used in average case)
'5) holds starting goods
'6) holds the required goods
'7) holds the expended goods

'Second Dim
'1) Cost
'2) Avail
'3) lcm
'4) hcm
'5) mil or guns

'Path cost variable for dist point total mob cost
Dim pvar As Variant
Dim pcost As Single
Dim mcost As Single
Dim total_mcost As Single
Dim pb As Integer
Dim tvar As Variant
Dim strDistPoint As String
Dim rsSect As Recordset

tvar = True
strDistPoint = ""
If Not (sx1 = 0 And sy1 = 1) Then
    strDistPoint = SectorString(sx1, sy1)
    
    'find the dist point's post update packing bonus
    rsSectors.Seek "=", sx1, sy1
    If Not rsSectors.NoMatch Then
        v = Production(rsSectors)
        If IsArray(v) Then
            If CInt(v(1)) < 60 Then
                pb = PB_NONE
            ElseIf CStr(v(5)) = "h" Or CStr(v(5)) = "w" Then
                pb = PB_WAREHOUSE
            ElseIf CStr(v(5)) = "b" Then
                pb = PB_BANK
            Else
                pb = PB_CIVS
            End If
        End If
    End If
End If

'Set the items
ar(PR_FOOD, PR_ITEM) = "food"
ar(PR_IRON, PR_ITEM) = "iron"
ar(PR_LCM, PR_ITEM) = "lcm"
ar(PR_HCM, PR_ITEM) = "hcm"
ar(PR_DUST, PR_ITEM) = "dust"
ar(PR_BAR, PR_ITEM) = "bar"
ar(PR_GUN, PR_ITEM) = "gun"
ar(PR_SHELL, PR_ITEM) = "shell"
ar(PR_OIL, PR_ITEM) = "oil"
ar(PR_PET, PR_ITEM) = "pet"
ar(PR_MIL, PR_ITEM) = "mil"
ar(PR_RAD, PR_ITEM) = "rad"
ar(PR_CIV, PR_ITEM) = "civ"
ar(PR_UW, PR_ITEM) = "uw"
ar(PR_HAPPY, PR_ITEM) = "stroll"
ar(PR_GRAD, PR_ITEM) = "grad"
ar(PR_TECH, PR_ITEM) = "tech"
ar(PR_RESCH, PR_ITEM) = "research"
ar(PR_SHIP, PR_ITEM) = "ships"
ar(PR_PLANE, PR_ITEM) = "planes"
ar(PR_ARMY, PR_ITEM) = "armies"
ar(PR_CITY, PR_ITEM) = "cities"
ar(PR_FORT, PR_ITEM) = "forts"

'Clear Event Markers
EventMarkers.Clear

'Scan production for Grads, tech units, etc.
Set rsSect = rsSectors.Clone
If Not (rsSect.BOF And rsSect.EOF) Then
    rsSect.MoveFirst
    While Not rsSect.EOF
    
        If (sx1 = 0 And sy1 = 1) Or _
        (rsSect.Fields("dist_x") = sx1 And rsSect.Fields("dist_y") = sy1) Then

            'set if captured sector
            If rsSect.Fields("*").Value = "*" Then
                strCapt = "*"
            Else
                strCapt = " "
            End If
            
            strSect = SectorString(rsSect.Fields("x").Value, rsSect.Fields("y").Value)
            strSectHeader = "Sector " + PadString(strSect, 8, False) _
                   + PadString(CStr(rsSect.Fields("eff").Value), 3) + "% " + rsSect.Fields("des").Value + rsSect.Fields("sdes").Value + strCapt _
            
            'Get the post-update path cost to the sector
            pvar = BestPath(strDistPoint, strSect, MT_COMMODITY, tvar)
            pcost = pvar(2)

            'Clear the sector commodity array
            For n = 1 To PR_COMM_ITEM
                For n2 = 1 To PR_CATG_LAST
                    sc(n, n2) = 0
            Next n2, n

            'get the food needed/available
            n = FoodRequired(rsSect)
            If n >= 0 Then
                ar(PR_FOOD, PR_USED) = ar(PR_FOOD, PR_USED) + n
                sc(PR_FOOD, PR_USED) = n
            End If
            
            'If there is not enough food, save a warning message
            If ShowStarve And rsSect.Fields("food").Value - n < 0 Then
                strLine = "Needs " + CStr(n - rsSect.Fields("food").Value) + " food"
                cp(1).Add strSectHeader + " - " + strLine
                MarkSector strSect, -1, strLine
            End If
            
            'get the on-hand amount
            For n = 1 To PR_COMM_ITEM
                ar(n, PR_ONHAND) = ar(n, PR_ONHAND) + rsSect.Fields(CStr(ar(n, PR_ITEM)))
                sc(n, PR_ONHAND) = rsSect.Fields(CStr(ar(n, PR_ITEM)))
            Next n
            
            'get the requested amount
            For n = 1 To PR_COMM_ITEM
                ar(n, PR_RQST) = ar(n, PR_RQST) + rsSect.Fields(Left(CStr(ar(n, PR_ITEM)), 1) + "_dist")
                sc(n, PR_RQST) = rsSect.Fields(Left(CStr(ar(n, PR_ITEM)), 1) + "_dist")
            Next n
            
            'handle civ and uw growth
            sc(PR_CIV, PR_MADE) = Int(NewPop(rsSect, "c"))
            sc(PR_UW, PR_MADE) = Int(NewPop(rsSect, "u"))
            ar(PR_CIV, PR_MADE) = ar(PR_CIV, PR_MADE) + sc(PR_CIV, PR_MADE)
            ar(PR_UW, PR_MADE) = ar(PR_UW, PR_MADE) + sc(PR_UW, PR_MADE)
            
            'get the production
            v = Production(rsSect)
            If IsArray(v) Then
                Select Case CStr(v(5))
                   Case "m"
                        ar(PR_IRON, PR_MADE) = ar(PR_IRON, PR_MADE) + v(2)
                        sc(PR_IRON, PR_MADE) = v(2)
                    Case "g", "^"
                        ar(PR_DUST, PR_MADE) = ar(PR_DUST, PR_MADE) + v(2)
                        sc(PR_DUST, PR_MADE) = v(2)
                    Case "u"
                        ar(PR_RAD, PR_MADE) = ar(PR_RAD, PR_MADE) + v(2)
                        sc(PR_RAD, PR_MADE) = v(2)
                    Case "o"
                        ar(PR_OIL, PR_MADE) = ar(PR_OIL, PR_MADE) + v(2)
                        sc(PR_OIL, PR_MADE) = v(2)
                    Case "a"
                        ar(PR_FOOD, PR_MADE) = ar(PR_FOOD, PR_MADE) + v(2)
                        sc(PR_FOOD, PR_MADE) = v(2)
                    Case "e"
                        ar(PR_MIL, PR_MADE) = ar(PR_MIL, PR_MADE) + v(2)
                        sc(PR_MIL, PR_MADE) = v(2)
                        ar(PR_CIV, PR_USED) = ar(PR_CIV, PR_USED) + v(2)
                        sc(PR_CIV, PR_USED) = v(2)
                    Case "j"
                        ar(PR_LCM, PR_MADE) = ar(PR_LCM, PR_MADE) + v(2)
                        ar(PR_IRON, PR_USED) = ar(PR_IRON, PR_USED) + v(6)
                        sc(PR_LCM, PR_MADE) = v(2)
                        sc(PR_IRON, PR_USED) = v(6)
                        ut(PR_IRON, PR_LCM) = ut(PR_IRON, PR_LCM) + v(6)
                    Case "k"
                        ar(PR_HCM, PR_MADE) = ar(PR_HCM, PR_MADE) + v(2)
                        ar(PR_IRON, PR_USED) = ar(PR_IRON, PR_USED) + v(6) * 2
                        sc(PR_HCM, PR_MADE) = v(2)
                        sc(PR_IRON, PR_USED) = v(6) * 2
                        ut(PR_IRON, PR_HCM) = ut(PR_IRON, PR_HCM) + v(6) * 2
                    Case "b"
                        ar(PR_BAR, PR_MADE) = ar(PR_BAR, PR_MADE) + v(2)
                        ar(PR_DUST, PR_USED) = ar(PR_DUST, PR_USED) + v(6) * 5
                        sc(PR_BAR, PR_MADE) = v(2)
                        sc(PR_DUST, PR_USED) = v(6) * 5
                        ut(PR_DUST, PR_BAR) = ut(PR_DUST, PR_BAR) + v(6) * 5
                   Case "c"
                        If rsVersion.Fields("BIG_CITY") Then 'count what it takes to build up the sector
                            n = rsSect.Fields("eff")
                            If rsSect.Fields("des") <> "c" Then
                                n = 0
                            End If
                            n = CInt(v(1)) - n 'new efficiency- current efficiency
                            If n > 0 Then
                                ar(PR_LCM, PR_USED) = ar(PR_LCM, PR_USED) + n
                                ar(PR_HCM, PR_USED) = ar(PR_HCM, PR_USED) + n * 2
                                sc(PR_LCM, PR_USED) = n
                                sc(PR_HCM, PR_USED) = n * 2
                                ar(PR_CITY, PR_MADE) = ar(PR_CITY, PR_MADE) + 1
                                ut(PR_LCM, PR_CITY) = ut(PR_LCM, PR_CITY) + n
                                ut(PR_HCM, PR_CITY) = ut(PR_HCM, PR_CITY) + n * 2
                            End If
                        End If
                   Case "i"
                        ar(PR_SHELL, PR_MADE) = ar(PR_SHELL, PR_MADE) + v(2)
                        ar(PR_LCM, PR_USED) = ar(PR_LCM, PR_USED) + v(6) * 2
                        ar(PR_HCM, PR_USED) = ar(PR_HCM, PR_USED) + v(6)
                        sc(PR_SHELL, PR_MADE) = v(2)
                        sc(PR_LCM, PR_USED) = v(6) * 2
                        sc(PR_HCM, PR_USED) = v(6)
                        ut(PR_LCM, PR_SHELL) = ut(PR_LCM, PR_SHELL) + v(6) * 2
                        ut(PR_HCM, PR_SHELL) = ut(PR_HCM, PR_SHELL) + v(6) * 1
                    Case "d"
                        ar(PR_GUN, PR_MADE) = ar(PR_GUN, PR_MADE) + v(2)
                        ar(PR_OIL, PR_USED) = ar(PR_OIL, PR_USED) + v(6)
                        ar(PR_LCM, PR_USED) = ar(PR_LCM, PR_USED) + v(6) * 5
                        ar(PR_HCM, PR_USED) = ar(PR_HCM, PR_USED) + v(6) * 10
                        sc(PR_GUN, PR_MADE) = v(2)
                        sc(PR_OIL, PR_USED) = v(6)
                        sc(PR_LCM, PR_USED) = v(6) * 5
                        sc(PR_HCM, PR_USED) = v(6) * 10
                        ut(PR_LCM, PR_GUN) = ut(PR_LCM, PR_GUN) + v(6) * 5
                        ut(PR_HCM, PR_GUN) = ut(PR_HCM, PR_GUN) + v(6) * 10
                        ut(PR_OIL, PR_GUN) = ut(PR_OIL, PR_GUN) + v(6)
                     Case "%"
                        ar(PR_PET, PR_MADE) = ar(PR_PET, PR_MADE) + v(2)
                        ar(PR_OIL, PR_USED) = ar(PR_OIL, PR_USED) + v(6)
                        sc(PR_PET, PR_MADE) = v(2)
                        sc(PR_OIL, PR_USED) = v(6)
                        ut(PR_OIL, PR_PET) = ut(PR_OIL, PR_PET) + v(6)
                     Case "l"
                        ar(PR_GRAD, PR_MADE) = ar(PR_GRAD, PR_MADE) + v(2)
                        ar(PR_LCM, PR_USED) = ar(PR_LCM, PR_USED) + v(6)
                        sc(PR_LCM, PR_USED) = v(6)
                        ut(PR_LCM, PR_GRAD) = ut(PR_LCM, PR_GRAD) + v(6)
                     Case "p"
                        ar(PR_HAPPY, PR_MADE) = ar(PR_HAPPY, PR_MADE) + v(2)
                        ar(PR_LCM, PR_USED) = ar(PR_LCM, PR_USED) + v(6)
                        sc(PR_LCM, PR_USED) = v(6)
                        ut(PR_LCM, PR_HAPPY) = ut(PR_LCM, PR_HAPPY) + v(6)
                     Case "t"
                        ar(PR_TECH, PR_MADE) = ar(PR_TECH, PR_MADE) + v(2)
                        ar(PR_DUST, PR_USED) = ar(PR_DUST, PR_USED) + v(6)
                        ar(PR_OIL, PR_USED) = ar(PR_OIL, PR_USED) + v(6) * 5
                        ar(PR_LCM, PR_USED) = ar(PR_LCM, PR_USED) + v(6) * 10
                        sc(PR_DUST, PR_USED) = v(6)
                        sc(PR_OIL, PR_USED) = v(6) * 5
                        sc(PR_LCM, PR_USED) = v(6) * 10
                        ut(PR_DUST, PR_TECH) = ut(PR_DUST, PR_TECH) + v(6)
                        ut(PR_OIL, PR_TECH) = ut(PR_OIL, PR_TECH) + v(6) * 5
                        ut(PR_LCM, PR_TECH) = ut(PR_LCM, PR_TECH) + v(6) * 10
                     Case "r"
                        ar(PR_RESCH, PR_MADE) = ar(PR_RESCH, PR_MADE) + v(2)
                        ar(PR_DUST, PR_USED) = ar(PR_DUST, PR_USED) + v(6)
                        ar(PR_OIL, PR_USED) = ar(PR_OIL, PR_USED) + v(6) * 5
                        ar(PR_LCM, PR_USED) = ar(PR_LCM, PR_USED) + v(6) * 10
                        sc(PR_DUST, PR_USED) = v(6)
                        sc(PR_OIL, PR_USED) = v(6) * 5
                        sc(PR_LCM, PR_USED) = v(6) * 10
                        ut(PR_DUST, PR_RESCH) = ut(PR_DUST, PR_RESCH) + v(6)
                        ut(PR_OIL, PR_RESCH) = ut(PR_OIL, PR_RESCH) + v(6) * 5
                        ut(PR_LCM, PR_RESCH) = ut(PR_LCM, PR_RESCH) + v(6) * 10
                    
                    'for harbors, etc - we have to simulate builds.
                    Case "*", "h", "!", "f"
                        
                        For n = 1 To 5
                            For n2 = 1 To 7
                                Costs(n2, n) = 0
                        Next n2, n
                        
                        If CInt(v(1)) > 59 Then
                            Costs(5, 1) = 9999999        'Assume enough money
                            Costs(5, 2) = rsSect.Fields("avail")  'avail
                            Costs(5, 3) = rsSect.Fields("lcm")  'lcm
                            Costs(5, 4) = rsSect.Fields("hcm")  'hcm
                            CostDesc(2) = "avail"
                            CostDesc(3) = ar(PR_LCM, PR_ITEM)
                            CostDesc(4) = ar(PR_HCM, PR_ITEM)
                            
                            n2 = 0 ' will hold count
                            Select Case CStr(v(5))
                                Case "h"
                                    Set rs = rsShip
                                    BuildType = "s"
                                    MaxEffGain = rsVersion.Fields("Eff gain - Ship")
                                    Target = PR_SHIP
                                    LastItem = 1
                                    'check for post update avail used
                                    If HarborAvail Then
                                         Costs(5, 2) = CInt(v(2))
                                    End If
                                    
                                    Costs(5, 5) = 9999  'nothing
                
                                Case "!", "f"
                                    Set rs = rsLand
                                    BuildType = "l"
                                    MaxEffGain = rsVersion.Fields("Eff gain - Land")
                                    Target = PR_ARMY
                                    LastItem = PR_GUN
                                    Costs(5, 5) = rsSect.Fields("gun")
                                    CostDesc(5) = ar(LastItem, PR_ITEM)
                                    'check for post update avail used
                                    If (CStr(v(5)) = "!" And HQAvail) Or _
                                       (CStr(v(5)) = "f" And FortAvail) Then
                                        Costs(5, 2) = CInt(v(2))
                                    End If
        
                                Case "*"
                                    Set rs = rsPlane
                                    BuildType = "p"
                                    MaxEffGain = rsVersion.Fields("Eff gain - Plane")
                                    Target = PR_PLANE
                                    LastItem = PR_MIL
                                    'check for post update avail used
                                    If AirportAvail Then
                                         Costs(5, 2) = CInt(v(2))
                                    End If

                                    Costs(5, 5) = rsSect.Fields("mil")
                                    CostDesc(5) = ar(LastItem, PR_ITEM)
                            End Select
                                
                            'Now run through the units
                            If Not (rs.BOF And rs.EOF) Then
                                rs.MoveFirst
                            End If
                            While Not rs.EOF
                            
                                'Check to see if it is in this hex
                                If rsSect.Fields("x") = rs.Fields("x") And rsSect.Fields("y") = rs.Fields("y") Then
                                
                                    'check to see that it is not 100% already
                                    If rs.Fields("eff") < 100 Then
                                        'get the build requirements
                                        rsBuild.Seek "=", BuildType, rs.Fields("type")
                                        If Not rsBuild.NoMatch Then
                                            'Compute efficieny gain
                                            neweff = rs.Fields("eff") + MaxEffGain
                                            If neweff > 100 Then
                                                neweff = 100
                                            End If
                                            effgain = (neweff - rs.Fields("eff")) / 100
                                            
                                            'load costs
                                            Costs(1, 1) = rsBuild.Fields("cost")
                                            Costs(1, 3) = rsBuild.Fields("lcm")
                                            Costs(1, 4) = rsBuild.Fields("hcm")
                                            Costs(1, 2) = 20 + rsBuild.Fields("lcm") + rsBuild.Fields("hcm") * 2
                                            Select Case CStr(v(5))
                                                Case "h"
                                                    Costs(1, 5) = 0
                                                Case "*"
                                                    Costs(1, 5) = rsBuild.Fields("mil")
                                                Case Else
                                                    Costs(1, 5) = rsBuild.Fields("gun")
                                            End Select
                                            For n = 1 To 5
                                               Costs(2, n) = Costs(1, n) * effgain
                                               Costs(3, n) = CSng(Int(Costs(2, n) + 0.995))
                                               Costs(6, n) = Costs(6, n) + Costs(3, n)
                                            Next n
                                            ar(Target, PR_MADE) = ar(Target, PR_MADE) + 1
                                            n2 = n2 + 1
                                        End If
                                   End If
                                End If
                                rs.MoveNext
                            Wend
                            
                            'Put out build message
                            Dim strTemp As String
                            If Costs(6, 2) > 0 Then
                                strTemp = strSectHeader + " - building " + CStr(n2) + " " + ar(Target, PR_ITEM) + "."
                            Else
                                strTemp = strSectHeader + " - is idle."
                            End If
                            
                            If Costs(5, 2) > Costs(6, 2) Then
                                strTemp = strTemp + " " + CStr(Costs(5, 2) - Costs(6, 2)) + " avail left."
                            End If
                            cp(6).Add strTemp
                            
                            'check for shortages
                            For n = 2 To 5
                                If Costs(6, n) > Costs(5, n) Then
                                    cp(6).Add strSectHeader + " - is short " _
                                        + CStr(Costs(6, n) - Costs(5, n)) + " " + CostDesc(n) + " for builds"
                                End If
                            Next
    
                            'add to arrays
                            ar(PR_LCM, PR_USED) = ar(PR_LCM, PR_USED) + Costs(6, 3)
                            ar(PR_HCM, PR_USED) = ar(PR_HCM, PR_USED) + Costs(6, 4)
                            ar(LastItem, PR_USED) = ar(LastItem, PR_USED) + Costs(6, 5)
                            sc(PR_LCM, PR_USED) = sc(PR_LCM, PR_USED) + Costs(6, 3)
                            sc(PR_HCM, PR_USED) = sc(PR_HCM, PR_USED) + Costs(6, 4)
                            sc(LastItem, PR_USED) = sc(LastItem, PR_USED) + Costs(6, 5)
                            ut(PR_LCM, Target) = ut(PR_LCM, Target) + Costs(6, 3)
                            ut(PR_HCM, Target) = ut(PR_HCM, Target) + Costs(6, 4)
                            ut(LastItem, Target) = ut(LastItem, Target) + Costs(6, 5)
                        
                        End If
                        'handle new forts being built
                        If CStr(v(5)) = "f" Then
                            n = rsSect.Fields("eff")
                            If rsSect.Fields("des") <> "f" Then
                                n = 0
                            End If
                            n = CInt(v(1)) - n 'new efficiency- current efficiency
                            If n > 0 Then
                                ar(PR_HCM, PR_USED) = ar(PR_HCM, PR_USED) + n
                                ar(PR_FORT, PR_MADE) = ar(PR_FORT, PR_MADE) + 1
                                ut(PR_HCM, PR_FORT) = ut(PR_HCM, PR_FORT) + n
                            End If
                        End If
                    
                    Case Else
                End Select
            
                n = CInt(v(4))
                'if we are short civs, let us know about it
                If n < 0 And InStr("h*!f", rsSect.Fields("des").Value) = 0 Then
                    cp(4).Add strSectHeader + " - " + CStr(0 - n) + " civs needed"
                End If
                
                'If there are excess civs, save a warning message
                If ShowIdle And n > 10 And strCapt = " " Then
                    cp(5).Add strSectHeader + " - " + CStr(n) + " idle civs"
                    MarkSector strSect, -1, "Idle civs"
                End If
            End If
            
            'if there are too many uws, save a warning message
            If ShowOvrPop And rsSect.Fields("uw") > MaxSafeUws Then
                cp(3).Add strSectHeader + " - Over MaxSafeUws by " + CStr(rsSect.Fields("uw").Value - MaxSafeUws) + " uws"
                MarkSector strSect, -1, "Over Max Safe Uws"
            End If
             
            'if there are too many civs, and its not a captured sector, save a warning message
            If ShowOvrPop And strCapt = " " Then
                If rsVersion.Fields("BIG_CITY") And rsSect.Fields("des") = "c" Then
                    If rsSect.Fields("civ") > (((MaxSafeCivs + 1) * rsSect.Fields("eff")) / 10) Then
                        cp(2).Add strSectHeader + " - Over MaxSafeCivs by " + CStr(rsSect.Fields("civ").Value - (MaxSafeCivs * rsSect.Fields("eff")) / 10) + " civs"
                        MarkSector strSect, -1, "Over Max Safe Civs"
                    End If
                ElseIf rsSect.Fields("civ") > CInt(MaxSafeCivs / 10) And rsSect.Fields("des") = "^" Then
                    cp(2).Add strSectHeader + " - Over MaxSafeCivs by " + CStr(rsSect.Fields("civ").Value - CInt(MaxSafeCivs / 10)) + " civs"
                    MarkSector strSect, -1, "Over Max Safe Civs"
                ElseIf rsSect.Fields("civ") > (MaxSafeCivs + 1) Then
                    cp(2).Add strSectHeader + " - Over MaxSafeCivs by " + CStr(rsSect.Fields("civ").Value - MaxSafeCivs) + " civs"
                    MarkSector strSect, -1, "Over Max Safe Civs"
                End If
            End If
            
            'Figure out the total mob cost to ship to the sector
            For n = 1 To PR_COMM_ITEM
                If pcost > 0 And sc(n, PR_RQST) > 0 Then
                    n2 = sc(n, PR_RQST) - (sc(n, PR_ONHAND) + sc(n, PR_MADE) - sc(n, PR_USED))
                    If n2 > 0 Then
                        mcost = (pcost * MobilityWeight(Left(ar(n, PR_ITEM), 1), n2, pb)) / 10#
                        total_mcost = total_mcost + mcost
                    End If
                End If
            Next n
        
        End If
        rsSect.MoveNext
    Wend

End If
            

'Set Report
frmReport.Caption = "Area Production Summary"
frmReport.ClearReport

'Const PR_ITEM = 1
'Const PR_ONHAND = 2
'Const PR_MADE = 3
'Const PR_USED = 4
'Const PR_CATG_LAST = 6

'Set Summary Headers
strLine = PadString("ITEM", 8, False) + PadString("ON HAND", 8) + PadString("MAKING", 8) + PadString("USING", 8) _
            + PadString("DELTA", 8) + PadString("LEFT", 8) + PadString("THRSHLD", 8) + PadString("EXCESS", 8)
frmReport.AddReportLine strLine

'write Summaries
For n = 1 To PR_COMM_ITEM
    strLine = PadString(CStr(ar(n, PR_ITEM)), 8, False)
    For n2 = 2 To 4
        strLine = strLine + PadString(Format(ar(n, n2), "###,##0"), 8)
    Next n2
    strLine = strLine + PadString(Format(ar(n, PR_MADE) - ar(n, PR_USED), "###,##0"), 8)
    strLine = strLine + PadString(Format(ar(n, PR_ONHAND) + ar(n, PR_MADE) - ar(n, PR_USED), "###,##0"), 8)
    strLine = strLine + PadString(Format(ar(n, PR_RQST), "###,##0"), 8)
    strLine = strLine + PadString(Format(ar(n, PR_ONHAND) + ar(n, PR_MADE) - ar(n, PR_USED) - ar(n, PR_RQST), "###,##0"), 8)
    
    frmReport.AddReportLine strLine
Next n

'if this is a single dist point, write out cost
If Len(strDistPoint) > 0 Then
    frmReport.AddReportLine ""
    strLine = "Distribution mob. cost: " + CStr(CSng(CLng(CSng(total_mcost) * 1000) / 1000))
    frmReport.AddReportLine strLine
    frmReport.AddReportLine ""
End If

'Put out item usage details
For n = 1 To PR_COMM_ITEM
    For n2 = 1 To PR_COMM_LAST
        ut(n, 0) = ut(n, 0) + ut(n, n2)
    Next n2
    If ut(n, 0) > 0 Then
        frmReport.AddReportLine ""
        frmReport.AddReportLine CStr(ar(n, PR_ITEM)) + " Summary - " + Format(ut(n, 0), "###,##0") + " used"
        For n2 = 1 To PR_COMM_LAST
            If ut(n, n2) > 0 Then
                frmReport.AddReportLine PadString(Format(ut(n, n2), "###,##0"), 8) + " used in making" _
                    + PadString(Format(ar(n2, PR_MADE), "###,##0"), 8) + " " + CStr(ar(n2, PR_ITEM))
            End If
        Next n2
    End If
Next n
    
frmReport.AddReportLine ""
For n = 1 To PR_MSGC
    For Each varLine In cp(n)
        frmReport.AddReportLine CStr(varLine)
    Next
    frmReport.AddReportLine ""
Next

frmReport.Show vbModeless
frmEmpCmd.SubmitEmpireCommand "db2", False

Exit Sub
Empire_Error:
EmpireError "ProdSummaryReport", "", ""
End Sub

Public Sub AirCombatReport()
On Error GoTo Empire_Error
Dim rs As Recordset
Dim hldkey As Variant
Dim hldstatus As String
Dim statuscount As Integer
Dim nationcount As Integer
Dim timActiveDate As Date
Dim n As Integer
Dim x As Integer
Dim strTemp As String
Dim numnations As Integer
Dim aryNations() As Integer
Dim Done As Boolean
Dim bCurrent As Boolean

Set rs = rsAirCombat
ReDim aryNations(Nations.Count)

If rs.BOF And rs.EOF Then
    frmReport.AddReportLine "No air combat history found"
Else
    hldkey = rs.Index
    
    rs.Index = "TimeKey"
    rs.MoveFirst
    If timActiveDate = timNextUpdate Then
        timActiveDate = rs.Fields("nextupdate")
    Else
        timActiveDate = timNextUpdate
    End If
    n = 1
    While Not rs.EOF
        'keep track the order in which nations are found
        If aryNations(rs.Fields("nation")) = 0 Then
            aryNations(rs.Fields("nation")) = n
            n = n + 1
        End If
    
        'Mark Historical
        If timActiveDate <> rs.Fields("nextupdate") Then
            If rs.Fields("status") = "A" Or rs.Fields("status") = "D" Then
                rs.Edit
                rs.Fields("status") = "T"
                rs.Fields("eff") = 100
                rs.Update
            ElseIf rs.Fields("status") = "S" Then
                rs.Edit
                rs.Fields("status") = "X"
                rs.Fields("eff") = 0
                rs.Update
            End If
        End If
        rs.MoveNext
    Wend
    numnations = n - 1
    
    'Now do report
    rs.Index = "ReportKey"
    For x = 1 To numnations
        n = 1
        While aryNations(n) <> x
            n = n + 1
        Wend
    
        rs.Seek ">=", n  'must use >= with a partial key
        frmReport.AddReportLine "Player #" + CStr(n) + " - " _
            + Nations.NationName(n)
        frmReport.AddReportLine ""
        hldstatus = ""
        nationcount = 0
        Done = False
        
        While Not Done
        
            'process status change
            If rs.Fields("status") <> hldstatus Then
                If Len(hldstatus) > 0 Then
                    frmReport.AddReportLine "     Total: " + CStr(statuscount) + " planes"
                    frmReport.AddReportLine ""
                End If
                Select Case rs.Fields("status")
                    Case "A"
                            frmReport.AddReportLine "Active"
                            frmReport.AddReportLine "======"
                            bCurrent = True
                    Case "D"
                            frmReport.AddReportLine "Disabled"
                            frmReport.AddReportLine "========"
                            bCurrent = True
                    Case "S"
                            frmReport.AddReportLine "Shot Down"
                            frmReport.AddReportLine "========="
                            bCurrent = True
                    Case "T"
                            frmReport.AddReportLine "Historical Active"
                            frmReport.AddReportLine "================="
                            bCurrent = False
                    Case "X"
                            frmReport.AddReportLine "Historical Shot Down"
                            frmReport.AddReportLine "===================="
                            bCurrent = False
                End Select
                hldstatus = rs.Fields("status")
                statuscount = 0
            End If
            
            'output line
            strTemp = "     " + rs.Fields("type") + " #" + PadString(CStr(rs.Fields("id")), 5, False)
            If bCurrent Then
                strTemp = strTemp + PadString(CStr(rs.Fields("eff")) + "%", 5) + "  " _
                + CStr(rs.Fields("numcombats")) + " combat"
                If rs.Fields("numcombats") > 1 Then
                    strTemp = strTemp + "s"
                End If
            End If
            frmReport.AddReportLine strTemp
            
            statuscount = statuscount + 1
            nationcount = nationcount + 1
            rs.MoveNext
            If rs.EOF Then
                Done = True
            ElseIf rs.Fields("nation") <> n Then
                Done = True
            End If
            
        Wend
        frmReport.AddReportLine "     Total: " + CStr(statuscount) + " planes"
        frmReport.AddReportLine ""
        frmReport.AddReportLine "Nation Total: " + CStr(nationcount) + " planes"
        frmReport.AddReportLine ""

    Next x
    rs.Index = hldkey
End If
    
frmReport.Show vbModeless
Exit Sub
Empire_Error:
EmpireError "AirCombatReport", "", ""
End Sub

Public Function ApplySectorDamage(strSect As String, nDamage As Integer, Optional bAbsolute As Boolean) As String
On Error GoTo Empire_Error

If IsMissing(bAbsolute) Then
    bAbsolute = False
End If

Dim sx As Integer
Dim sy As Integer
Dim seceff As Integer
Dim sectype As String
Dim found As Boolean
Dim neweff As Integer

If Not ParseSectors(sx, sy, strSect) Then
    ApplySectorDamage = ""
    Exit Function
End If

found = True
'check for your own sector
rsSectors.Seek "=", sx, sy
If Not rsSectors.NoMatch Then
    sectype = rsSectors.Fields("des").Value
    seceff = CStr(rsSectors.Fields("eff").Value)
    If bAbsolute Then
        neweff = seceff - nDamage
    Else
        neweff = SectorEffAfterDamage(nDamage, sectype, seceff)
    End If
    rsSectors.Edit
    rsSectors.Fields("eff").Value = neweff
    rsSectors.Update
Else
    'Check for Enemy Sector
    rsEnemySect.Seek "=", sx, sy
    If Not rsEnemySect.NoMatch Then
        sectype = rsEnemySect.Fields("des").Value
        seceff = rsEnemySect.Fields("eff").Value
        If bAbsolute Then
            neweff = seceff - nDamage
        Else
            neweff = SectorEffAfterDamage(nDamage, sectype, seceff)
        End If
        rsEnemySect.Edit
        rsEnemySect.Fields("eff").Value = neweff
        rsEnemySect.Update
    Else
        rsBmap.Seek "=", sx, sy
        If Not rsBmap.NoMatch Then
            sectype = rsBmap.Fields("des").Value
            seceff = 100
            If bAbsolute Then
                neweff = seceff - nDamage
            Else
                neweff = SectorEffAfterDamage(nDamage, sectype, seceff)
            End If
        Else
            ApplySectorDamage = "No information on " + strSect
            found = False
        End If
    End If
End If

If found Then
    ApplySectorDamage = "Sector " + strSect + " efficiency reduced from " _
        + CStr(seceff) + "% to " + CStr(neweff) + "%"
End If
Exit Function
Empire_Error:
EmpireError "ApplySectorDamage", "", strSect

End Function

Public Function ApplyShipDamage(strShip As String, nDamage As Integer, Optional bAbsolute As Boolean) As String
On Error GoTo Empire_Error
If IsMissing(bAbsolute) Then
    bAbsolute = False
End If

Dim neweff As Integer
Dim hldindex As Variant
Dim shipid As Integer
Dim seceff As Integer

shipid = CInt(strShip)

hldindex = rsShip.Index
rsShip.Index = "PrimaryKey"
'check for your own ships
rsShip.Seek "=", shipid
If Not rsShip.NoMatch Then
    seceff = CStr(rsShip.Fields("eff").Value)
    If bAbsolute Then
        neweff = seceff - nDamage
    Else
        'neweff = need to define raw damage routine
    End If
    rsShip.Edit
    rsShip.Fields("eff").Value = neweff
    rsShip.Update
    rsShip.Index = hldindex
Else
    'Check for enemy ship
    rsShip.Index = hldindex
    hldindex = rsEnemyUnit.Index
    rsEnemyUnit.Index = "ByID"
    rsEnemyUnit.Seek "=", "s", shipid
    If Not rsEnemySect.NoMatch Then
        seceff = rsEnemySect.Fields("eff").Value
        If seceff > 100 Then
            seceff = 100
        End If
        
        If bAbsolute Then
            neweff = seceff - nDamage
        Else
            'need to develop this routine
        End If
        rsEnemyUnit.Edit
        rsEnemyUnit.Fields("eff").Value = neweff
        rsEnemyUnit.Update
        rsEnemyUnit.Index = hldindex
    Else
        'build a ship record
        rsEnemyUnit.AddNew
        seceff = 100
        If bAbsolute Then
            neweff = seceff - nDamage
        Else
            'need to develop this routine
        End If
        rsEnemyUnit.Fields("eff").Value = neweff
        rsEnemyUnit.Fields("id").Value = shipid
        rsEnemyUnit.Fields("class").Value = "s"
        rsEnemyUnit.Fields("owner").Value = 0
        rsEnemyUnit.Fields("x").Value = -1
        rsEnemyUnit.Fields("y").Value = 0
        rsEnemyUnit.Fields("mil").Value = -1
        rsEnemyUnit.Update
    End If
End If

ApplyShipDamage = "Ship (#" + strShip + ") efficiency reduced from " _
    + CStr(seceff) + "% to " + CStr(neweff) + "%"

Exit Function
Empire_Error:
EmpireError "ApplyShipDamage", "", strShip

End Function

Public Sub CopySectorInfo(sx1 As Integer, sx2 As Integer, sy1 As Integer, sy2 As Integer, dx As Integer, dy As Integer, CopyType As Integer)
'On Error GoTo Empire_Error

Dim x As Integer
Dim Y As Integer
Dim tx As Integer
Dim ty As Integer
Dim n As Integer
Dim vhld() As Variant

For x = sx1 To sx2
    For Y = sy1 To sy2
        If (x + Y) Mod 2 = 0 Then
            rsSectors.Seek "=", x, Y
            If Not rsSectors.NoMatch Then
                ReDim vhld(0 To rsSectors.Fields.Count)
                For n = 0 To rsSectors.Fields.Count - 1
                    vhld(rsSectors.Fields(n).OrdinalPosition) = rsSectors.Fields(n).Value
                Next n
                tx = dx + x - sx1
                ty = dy + Y - sy1
                CopySector vhld, tx, ty, CopyType
            End If
        End If
    Next Y
Next x

'database update
frmEmpCmd.SubmitEmpireCommand "db1", False
frmEmpCmd.SubmitEmpireCommand "dump * ?timestamp>" + CStr(tsSectors), False
frmEmpCmd.SubmitEmpireCommand "db2", False

End Sub


Public Sub CopySector(vhld As Variant, tx As Integer, ty As Integer, CopyType As Integer)
'On Error GoTo Empire_Error

Dim n As Integer
Dim strDes As String
Dim strCmd As String
Dim strCmdDes As String
Dim strCom As String
Dim intRes As Integer

rsSectors.Seek "=", tx, ty
If Not rsSectors.NoMatch Then
    rsSectors.Edit
    strDes = vhld(rsSectors.Fields("des").OrdinalPosition)
    If rsSectors.Fields("des") <> strDes Then
        rsSectors.Fields("des").Value = strDes
        
        'designate the sector
        strCmdDes = "designate " + SectorString(tx, ty) + " " + strDes
        frmEmpCmd.SubmitEmpireCommand strCmdDes, True
        rsSectors.Fields("eff").Value = 0
    End If
    
    If strDes <> "." Then
        intRes = vhld(rsSectors.Fields("eff").OrdinalPosition) - rsSectors.Fields("eff").Value
        If intRes <> 0 Then
            rsSectors.Fields("eff").Value = rsSectors.Fields("eff").Value + intRes
            strCmd = "setsector eff " + SectorString(tx, ty) + " " + CStr(intRes)
            frmEmpCmd.SubmitEmpireCommand strCmd, True
        End If
        
        intRes = vhld(rsSectors.Fields("mob").OrdinalPosition) - rsSectors.Fields("mob").Value
        If intRes <> 0 Then
            rsSectors.Fields("mob").Value = rsSectors.Fields("mob").Value + intRes
            strCmd = "setsector mob " + SectorString(tx, ty) + " " + CStr(intRes)
            frmEmpCmd.SubmitEmpireCommand strCmd, True
        End If
        
        intRes = vhld(rsSectors.Fields("work").OrdinalPosition) - rsSectors.Fields("work").Value
        If intRes <> 0 Then
            rsSectors.Fields("work").Value = rsSectors.Fields("work").Value + intRes
            strCmd = "setsector work " + SectorString(tx, ty) + " " + CStr(intRes)
            frmEmpCmd.SubmitEmpireCommand strCmd, True
        End If
        
        intRes = vhld(rsSectors.Fields("avail").OrdinalPosition) - rsSectors.Fields("avail").Value
        If intRes <> 0 Then
            rsSectors.Fields("avail").Value = rsSectors.Fields("avail").Value + intRes
            strCmd = "setsector avail " + SectorString(tx, ty) + " " + CStr(intRes)
            frmEmpCmd.SubmitEmpireCommand strCmd, True
        End If
    End If
    
    'set resources
    If CopyType > 0 Then
        If strDes <> "." Then
            intRes = vhld(rsSectors.Fields("min").OrdinalPosition)
            If intRes <> rsSectors.Fields("min").Value Then
                rsSectors.Fields("min").Value = intRes
                strCmd = "setresource iron " + SectorString(tx, ty) + " " + CStr(intRes)
                frmEmpCmd.SubmitEmpireCommand strCmd, True
            End If
            
            intRes = vhld(rsSectors.Fields("gold").OrdinalPosition)
            If intRes <> rsSectors.Fields("gold").Value Then
                rsSectors.Fields("gold").Value = intRes
                strCmd = "setresource gold " + SectorString(tx, ty) + " " + CStr(intRes)
                frmEmpCmd.SubmitEmpireCommand strCmd, True
            End If
            
            intRes = vhld(rsSectors.Fields("uran").OrdinalPosition)
            If intRes <> rsSectors.Fields("uran").Value Then
                rsSectors.Fields("uran").Value = intRes
                strCmd = "setresource uran " + SectorString(tx, ty) + " " + CStr(intRes)
                frmEmpCmd.SubmitEmpireCommand strCmd, True
            End If
        End If
        
        intRes = vhld(rsSectors.Fields("ocontent").OrdinalPosition)
        If intRes <> rsSectors.Fields("ocontent").Value Then
            rsSectors.Fields("ocontent").Value = intRes
            strCmd = "setresource oil " + SectorString(tx, ty) + " " + CStr(intRes)
            frmEmpCmd.SubmitEmpireCommand strCmd, True
        End If
        
        intRes = vhld(rsSectors.Fields("fert").OrdinalPosition)
        If intRes <> rsSectors.Fields("fert").Value Then
            rsSectors.Fields("fert").Value = intRes
            strCmd = "setresource fert " + SectorString(tx, ty) + " " + CStr(intRes)
            frmEmpCmd.SubmitEmpireCommand strCmd, True
        End If
    End If
    
    'give commodities
    If CopyType > 1 And strDes <> "." Then
        strCom = "mil  gun  shellfood civ  uw   iron lcm  hcm  oil  dust pet  rad  bar  "
        For n = 0 To 13
            strCmd = Trim(Mid(strCom, 5 * n + 1, 5))
            intRes = vhld(rsSectors.Fields(strCmd).OrdinalPosition) - rsSectors.Fields(strCmd).Value
            If intRes <> 0 Then
                rsSectors.Fields(strCmd).Value = rsSectors.Fields(strCmd).Value + intRes
                strCmd = "give " + strCmd + " " + SectorString(tx, ty) + " " + CStr(intRes)
                frmEmpCmd.SubmitEmpireCommand strCmd, True
            End If
        Next n
    End If
    rsSectors.Update
End If

End Sub

Public Sub CopyGameInfo(DatabaseName, cx As Integer, cy As Integer)
'On Error GoTo Empire_Error

Dim sx As Integer
Dim sy As Integer
Dim tx As Integer
Dim ty As Integer
Dim n2 As Integer
Dim n As Integer
Dim nShip As Integer
Dim strName As String
Dim secowner As Integer
Dim vhld() As Variant
Dim rs As Recordset
Dim rsB As Recordset
Dim dbEmpireCopy As Database
Dim rsDShip As Recordset
Dim dbEmpireDeity As Database
Dim DeityName As String
Dim strDes As String
Dim strCmd As String
Dim strCmdDes As String
Dim strCom As String
Dim strTemp As String
Dim intRes As Integer
Dim hldindex As Variant
Dim Stage As Integer
Dim owner As Integer
Dim strSect As String


'Extract option from Data base name
n = InStr(DatabaseName, ":")
If n > 0 Then
    n2 = InStr(n + 1, DatabaseName, ":")
    If n2 = 0 Then Exit Sub
    Stage = val(Mid(DatabaseName, n + 1, n2 - n - 1))
    If Stage = 2 Then
        DeityName = Trim(Mid(DatabaseName, n2 + 1))
    Else
        owner = val(Trim(Mid(DatabaseName, n2 + 1)))
    End If
    DatabaseName = Trim(Left(DatabaseName, n - 1))
Else
    Exit Sub
End If

'Set Database name
strName = App.Path + "\" + DatabaseName + ".mdb"
Set dbEmpireCopy = OpenDatabase(strName, False, False)
ReDim vhld(0 To rsSectors.Fields.Count)

'Stage 0 - copy sectors and bmap (run from deity)
If Stage = 0 Then
    Set rs = dbEmpireCopy.OpenRecordset("Sectors")
    rs.Index = "PrimaryKey"
    If Not (rs.BOF And rs.EOF) Then
        rs.MoveFirst
    End If
    
    While Not rs.EOF
        For n = 0 To rs.Fields.Count - 1
            vhld(rs.Fields(n).OrdinalPosition) = rs.Fields(n).Value
        Next n
        tx = cx + rs.Fields("x")
        ty = cy + rs.Fields("y")
        OffsetSectorLocation tx, ty, 0, 0
        CopySector vhld, tx, ty, 3
        
        If owner = 0 Then
            secowner = rs.Fields("country")
        Else
            secowner = owner
        End If
        strCmd = "setsector oldown " + SectorString(tx, ty) + " " + CStr(secowner)
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector own " + SectorString(tx, ty) + " " + CStr(secowner)
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        rs.MoveNext
    Wend
    
    Set rsB = dbEmpireCopy.OpenRecordset("Bmap")
    rsB.Index = "PrimaryKey"
    If Not (rsB.BOF And rsB.EOF) Then
        rsB.MoveFirst
    End If
    
    While Not rsB.EOF
        rs.Seek "=", rsB.Fields("x"), rsB.Fields("y")
        If rs.NoMatch Then
            tx = cx + rsB.Fields("x")
            ty = cy + rsB.Fields("y")
            OffsetSectorLocation tx, ty, 0, 0
            strDes = rsB.Fields("des")
            If strDes = "?" Then strDes = "n"
            strCmd = "designate " + SectorString(tx, ty) + " " + strDes
            frmEmpCmd.SubmitEmpireCommand strCmd, True
            If strDes <> "." And strDes <> "-" Then
                rsSectors.Seek "=", tx, ty
                If Not rsSectors.NoMatch Then
                    intRes = 100 - rsSectors.Fields("eff").Value
                    strCmd = "setsector eff " + SectorString(tx, ty) + " " + CStr(intRes)
                    frmEmpCmd.SubmitEmpireCommand strCmd, True
                    
                    intRes = 127 - rsSectors.Fields("mob").Value
                    strCmd = "setsector mob " + SectorString(tx, ty) + " " + CStr(intRes)
                    frmEmpCmd.SubmitEmpireCommand strCmd, True
                    
                    intRes = 100 - rsSectors.Fields("work").Value
                    strCmd = "setsector work " + SectorString(tx, ty) + " " + CStr(intRes)
                    frmEmpCmd.SubmitEmpireCommand strCmd, True
                    
                    intRes = 600 - rsSectors.Fields("avail").Value
                    strCmd = "setsector avail " + SectorString(tx, ty) + " " + CStr(intRes)
                    frmEmpCmd.SubmitEmpireCommand strCmd, True
                End If
            End If
        End If
        rsB.MoveNext
    Wend
    
    'wipe out commodities from sea sectors
    strCom = "mil  gun  shellfood civ  uw   iron lcm  hcm  oil  dust pet  rad  bar  "
    For n = 0 To 13
        strCmd = Trim(Mid(strCom, 5 * n + 1, 5))
        strCmd = "give " + strCmd + " * ?des=.&" + strCmd + ">0 -9999"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
    Next n
    
    Set rs = Nothing
    Set rsB = Nothing
End If

'run from the diety, this setup a fake harbor for player account to
'build ships.  If the needed ships already exist, it scuttles them
If Stage = 1 Then
    
    'Open ship file
    Set rs = dbEmpireCopy.OpenRecordset("ship")
    rs.Index = "PrimaryKey"
    hldindex = rsShip.Index
    rsShip.Index = "PrimaryKey"
    
    tx = cx
    ty = cy
    strSect = SectorString(tx, ty)
    
    If Not (rs.BOF And rs.EOF) Then
        rs.MoveFirst
    
        'Setup a dummy harbor
        strCmd = "designate " + strSect + " " + "h"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector eff " + strSect + " 100"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector work " + strSect + " 100"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector avail " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "give hcm " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "give lcm " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "give mil " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector oldown " + strSect + " " + CStr(owner)
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector own " + strSect + " " + CStr(owner)
        frmEmpCmd.SubmitEmpireCommand strCmd, True
    
        'scuttle any ships that already exist
        strTemp = ""
        While Not rs.EOF
            rsShip.Seek "=", rs.Fields("id")
            If Not rsShip.NoMatch Then
                strTemp = strTemp + CStr(rs.Fields("id")) + "/"
            End If
            rs.MoveNext
        Wend
        If Len(strTemp) > 0 Then
            strCmd = "scuttle ship " + Left(strTemp, Len(strTemp) - 1)
            frmEmpCmd.SubmitEmpireCommand strCmd, True
        End If
    End If
    rsShip.Index = hldindex
    Set rs = Nothing
    
    'Open land file
    Set rs = dbEmpireCopy.OpenRecordset("land")
    rs.Index = "PrimaryKey"
    hldindex = rsLand.Index
    rsLand.Index = "PrimaryKey"
    
    tx = cx + 2
    ty = cy
    
    If Not (rs.BOF And rs.EOF) Then
        rs.MoveFirst
    
        'Setup a dummy hq
        strCmd = "designate " + strSect + " " + "!"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector eff " + strSect + " 100"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector work " + strSect + " 100"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector avail " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "give hcm " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "give lcm " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "give gun " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector oldown " + strSect + " " + CStr(owner)
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector own " + strSect + " " + CStr(owner)
        frmEmpCmd.SubmitEmpireCommand strCmd, True
    
        'scuttle any lands that already exist
        strTemp = ""
        While Not rs.EOF
            rsLand.Seek "=", rs.Fields("id")
            If Not rsLand.NoMatch Then
                strTemp = strTemp + CStr(rs.Fields("id")) + "/"
            End If
            rs.MoveNext
        Wend
        If Len(strTemp) > 0 Then
            strCmd = "scuttle land " + Left(strTemp, Len(strTemp) - 1)
            frmEmpCmd.SubmitEmpireCommand strCmd, True
        End If
    End If
    rsLand.Index = hldindex
    Set rs = Nothing
    
        'Open land file
    Set rs = dbEmpireCopy.OpenRecordset("plane")
    rs.Index = "PrimaryKey"
    hldindex = rsLand.Index
    rsPlane.Index = "PrimaryKey"
    
    tx = cx + 4
    ty = cy
    
    If Not (rs.BOF And rs.EOF) Then
        rs.MoveFirst
    
        'Setup a dummy airport
        strCmd = "designate " + strSect + " " + "*"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector eff " + strSect + " 100"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector work " + strSect + " 100"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector avail " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "give hcm " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "give lcm " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "give mil " + strSect + " 9000"
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector oldown " + strSect + " " + CStr(owner)
        frmEmpCmd.SubmitEmpireCommand strCmd, True
        strCmd = "setsector own " + strSect + " " + CStr(owner)
        frmEmpCmd.SubmitEmpireCommand strCmd, True
    
        'scuttle any planes that already exist
        strTemp = ""
        While Not rs.EOF
            rsPlane.Seek "=", rs.Fields("id")
            If Not rsPlane.NoMatch Then
                strTemp = strTemp + CStr(rs.Fields("id")) + "/"
            End If
            rs.MoveNext
        Wend
        If Len(strTemp) > 0 Then
            strCmd = "scuttle plane " + Left(strTemp, Len(strTemp) - 1)
            frmEmpCmd.SubmitEmpireCommand strCmd, True
        End If
    End If
    rsLand.Index = hldindex
    Set rs = Nothing

End If

'build the ships at the dummy harbor (0,0) (run from player account)
If Stage = 2 Then

    Set rs = dbEmpireCopy.OpenRecordset("ship")
    rs.Index = "PrimaryKey"

    'Set Database name
    strName = App.Path + "\" + DeityName + ".mdb"
    Set dbEmpireDeity = OpenDatabase(strName, False, False)
    Set rsDShip = dbEmpireDeity.OpenRecordset("ship")
    rsDShip.Index = "PrimaryKey"
    
    tx = 0
    ty = 0
    
    If Not (rs.BOF And rs.EOF) Then
        rs.MoveFirst
    
        If Not (rsDShip.BOF And rsDShip.EOF) Then
            rsDShip.MoveFirst
        End If
        nShip = 0
        While Not rs.EOF
            'need a filler ship
            If nShip < rs.Fields("id") Then
                If Not rsDShip.EOF Then
                    If nShip = rsDShip.Fields("id") Then
                        rsDShip.MoveNext
                    Else
                        strCmd = "build ship " + SectorString(tx, ty) + " fb"
                        frmEmpCmd.SubmitEmpireCommand strCmd, True
                    End If
                Else
                    strCmd = "build ship " + SectorString(tx, ty) + " fb"
                    frmEmpCmd.SubmitEmpireCommand strCmd, True
                End If
            'need to build the ship
            ElseIf nShip = rs.Fields("id") Then
                strCmd = "build ship " + SectorString(tx, ty) + " " + rs.Fields("type") + " 1 " + CStr(rs.Fields("tech"))
                frmEmpCmd.SubmitEmpireCommand strCmd, True
                rs.MoveNext
            End If
            nShip = nShip + 1
        Wend
        
    End If
    Set rs = Nothing
    Set rsDShip = Nothing
    
    Set rsDShip = dbEmpireDeity.OpenRecordset("land")
    rsDShip.Index = "PrimaryKey"
    Set rs = dbEmpireCopy.OpenRecordset("land")
    rs.Index = "PrimaryKey"
    
    tx = 2
    ty = 0
    
    If Not (rs.BOF And rs.EOF) Then
        rs.MoveFirst
    
        If Not (rsDShip.BOF And rsDShip.EOF) Then
            rsDShip.MoveFirst
        End If
        nShip = 0
        While Not rs.EOF
            'need a filler ship
            If nShip < rs.Fields("id") Then
                If Not rsDShip.EOF Then
                    If nShip = rsDShip.Fields("id") Then
                        rsDShip.MoveNext
                    Else
                        strCmd = "build land " + SectorString(tx, ty) + " linf"
                        frmEmpCmd.SubmitEmpireCommand strCmd, True
                    End If
                Else
                    strCmd = "build land " + SectorString(tx, ty) + " linf"
                    frmEmpCmd.SubmitEmpireCommand strCmd, True
                End If
            'need to build the ship
            ElseIf nShip = rs.Fields("id") Then
                strCmd = "build land " + SectorString(tx, ty) + " " + rs.Fields("type") + " 1 " + CStr(rs.Fields("tech"))
                frmEmpCmd.SubmitEmpireCommand strCmd, True
                rs.MoveNext
            End If
            nShip = nShip + 1
        Wend
        
    End If
    Set rs = Nothing
    Set rsDShip = Nothing
    
    Set rsDShip = dbEmpireDeity.OpenRecordset("plane")
    rsDShip.Index = "PrimaryKey"
    Set rs = dbEmpireCopy.OpenRecordset("plane")
    rs.Index = "PrimaryKey"
    
    tx = 4
    ty = 0
    
    If Not (rs.BOF And rs.EOF) Then
        rs.MoveFirst
    
        If Not (rsDShip.BOF And rsDShip.EOF) Then
            rsDShip.MoveFirst
        End If
        nShip = 0
        While Not rs.EOF
            'need a filler ship
            If nShip < rs.Fields("id") Then
                If Not rsDShip.EOF Then
                    If nShip = rsDShip.Fields("id") Then
                        rsDShip.MoveNext
                    Else
                        strCmd = "build plane " + SectorString(tx, ty) + " f1"
                        frmEmpCmd.SubmitEmpireCommand strCmd, True
                    End If
                Else
                    strCmd = "build plane " + SectorString(tx, ty) + " f1"
                    frmEmpCmd.SubmitEmpireCommand strCmd, True
                End If
            'need to build the ship
            ElseIf nShip = rs.Fields("id") Then
                strCmd = "build plane " + SectorString(tx, ty) + " " + rs.Fields("type") + " 1 " + CStr(rs.Fields("tech"))
                frmEmpCmd.SubmitEmpireCommand strCmd, True
                rs.MoveNext
            End If
            nShip = nShip + 1
        Wend
        
    End If
    Set rs = Nothing
    Set rsDShip = Nothing
    dbEmpireDeity.Close
    
End If

'move the ships to the right places and set the right values
'run from the deity account
If Stage = 3 Then
    
    Set rs = dbEmpireCopy.OpenRecordset("ship")
    rs.Index = "PrimaryKey"

    If Not (rs.BOF And rs.EOF) Then
        rs.MoveFirst
        While Not rs.EOF
            sx = cx + rs.Fields("x")
            sy = cy + rs.Fields("y")
            OffsetSectorLocation sx, sy, 0, 0
            strCmd = ":L " + SectorString(sx, sy)
            strCmd = strCmd + ":T " + CStr(rs.Fields("tech"))
            strCmd = strCmd + ":M " + CStr(rs.Fields("mob"))
            strCmd = strCmd + ":Y " + CStr(rs.Fields("land"))
            strCmd = strCmd + ":E " + CStr(rs.Fields("eff"))
            If rs.Fields("pln") > 0 Then
                strCmd = strCmd + ":P " + CStr(rs.Fields("pln"))
            End If
            If rs.Fields("xl") > 0 Then
                strCmd = strCmd + ":X " + CStr(rs.Fields("xl"))
            End If
            If rs.Fields("he") > 0 Then
                strCmd = strCmd + ":H " + CStr(rs.Fields("he"))
            End If
            If rs.Fields("mil") > 0 Then
                strCmd = strCmd + ":m " + CStr(rs.Fields("mil"))
            End If
            If rs.Fields("civ") > 0 Then
                strCmd = strCmd + ":c " + CStr(rs.Fields("civ"))
            End If
            If rs.Fields("uw") > 0 Then
                strCmd = strCmd + ":u " + CStr(rs.Fields("uw"))
            End If
            If rs.Fields("food") > 0 Then
                strCmd = strCmd + ":f " + CStr(rs.Fields("food"))
            End If
            If rs.Fields("gun") > 0 Then
                strCmd = strCmd + ":g " + CStr(rs.Fields("gun"))
            End If
            If rs.Fields("shell") > 0 Then
                strCmd = strCmd + ":s " + CStr(rs.Fields("shell"))
            End If
            If rs.Fields("iron") > 0 Then
                strCmd = strCmd + ":i " + CStr(rs.Fields("iron"))
            End If
            If rs.Fields("dust") > 0 Then
                strCmd = strCmd + ":d " + CStr(rs.Fields("dust"))
            End If
            If rs.Fields("oil") > 0 Then
                strCmd = strCmd + ":o " + CStr(rs.Fields("oil"))
            End If
            If rs.Fields("petrol") > 0 Then
                strCmd = strCmd + ":p " + CStr(rs.Fields("petrol"))
            End If
            If rs.Fields("lcm") > 0 Then
                strCmd = strCmd + ":l " + CStr(rs.Fields("lcm"))
            End If
            If rs.Fields("hcm") > 0 Then
                strCmd = strCmd + ":h " + CStr(rs.Fields("hcm"))
            End If
            If rs.Fields("rad") > 0 Then
                strCmd = strCmd + ":r " + CStr(rs.Fields("rad"))
            End If
            strCmd = "edit ship " + CStr(rs.Fields("id")) + strCmd
            frmEmpCmd.SubmitEmpireCommand strCmd, True
            rs.MoveNext
        Wend
    End If
    Set rs = Nothing
    
    sx = 0
    sy = 0
    tx = cx + sx
    ty = cy + sy
    OffsetSectorLocation tx, ty, 0, 0
    
    'now scrap the filler ships
    strCmd = "scuttle ship * ?type=fb&eff=20&x=" + CStr(tx) + "&y=" + CStr(ty)
    frmEmpCmd.SubmitEmpireCommand strCmd, True
        
    'Now get rid of dummy harbor
    Set rs = dbEmpireCopy.OpenRecordset("Sectors")
    rs.Index = "PrimaryKey"
    rs.Seek "=", sx, sy
    If rs.NoMatch Then
        strCmdDes = "designate " + SectorString(tx, ty) + " ."
        frmEmpCmd.SubmitEmpireCommand strCmdDes, True
    Else
        For n = 0 To rs.Fields.Count - 1
            vhld(rs.Fields(n).OrdinalPosition) = rs.Fields(n).Value
        Next n
        CopySector vhld, tx, ty, 3
    End If

    'Now do lands
    Set rs = dbEmpireCopy.OpenRecordset("land")
    rs.Index = "PrimaryKey"

    If Not (rs.BOF And rs.EOF) Then
        rs.MoveFirst
        While Not rs.EOF
            sx = cx + rs.Fields("x")
            sy = cy + rs.Fields("y")
            OffsetSectorLocation sx, sy, 0, 0
            strCmd = ":L " + SectorString(sx, sy)
            strCmd = strCmd + ":t " + CStr(rs.Fields("tech"))
            strCmd = strCmd + ":M " + CStr(rs.Fields("mob"))
            strCmd = strCmd + ":e " + CStr(rs.Fields("eff"))
            If rs.Fields("fort") > 0 Then
                strCmd = strCmd + ":F " + CStr(rs.Fields("fort"))
            End If
            If rs.Fields("fuel") > 0 Then
                strCmd = strCmd + ":B " + CStr(rs.Fields("fuel"))
            End If
            If rs.Fields("ship") > -1 Then
                strCmd = strCmd + ":S " + CStr(rs.Fields("ship"))
            End If
            If rs.Fields("land") > -1 Then
                strCmd = strCmd + ":Y " + CStr(rs.Fields("land"))
            End If
            If rs.Fields("xl") > 0 Then
                strCmd = strCmd + ":X " + CStr(rs.Fields("xl"))
            End If
            If rs.Fields("mil") > 0 Then
                strCmd = strCmd + ":m " + CStr(rs.Fields("mil"))
            End If
            If rs.Fields("food") > 0 Then
                strCmd = strCmd + ":f " + CStr(rs.Fields("food"))
            End If
            If rs.Fields("gun") > 0 Then
                strCmd = strCmd + ":g " + CStr(rs.Fields("gun"))
            End If
            If rs.Fields("shell") > 0 Then
                strCmd = strCmd + ":s " + CStr(rs.Fields("shell"))
            End If
            If rs.Fields("iron") > 0 Then
                strCmd = strCmd + ":i " + CStr(rs.Fields("iron"))
            End If
            If rs.Fields("dust") > 0 Then
                strCmd = strCmd + ":d " + CStr(rs.Fields("dust"))
            End If
            If rs.Fields("oil") > 0 Then
                strCmd = strCmd + ":o " + CStr(rs.Fields("oil"))
            End If
            If rs.Fields("petrol") > 0 Then
                strCmd = strCmd + ":p " + CStr(rs.Fields("petrol"))
            End If
            If rs.Fields("lcm") > 0 Then
                strCmd = strCmd + ":l " + CStr(rs.Fields("lcm"))
            End If
            If rs.Fields("hcm") > 0 Then
                strCmd = strCmd + ":h " + CStr(rs.Fields("hcm"))
            End If
            If rs.Fields("rad") > 0 Then
                strCmd = strCmd + ":r " + CStr(rs.Fields("rad"))
            End If
            strCmd = "edit unit " + CStr(rs.Fields("id")) + strCmd
            frmEmpCmd.SubmitEmpireCommand strCmd, True
            rs.MoveNext
        Wend
    End If
    Set rs = Nothing
    
    sx = 2
    sy = 0
    tx = cx + sx
    ty = cy + sy
    OffsetSectorLocation tx, ty, 0, 0
    
    'now scrap the filler ships
    strCmd = "scuttle land * ?type=linf&eff=10&x=" + CStr(tx) + "&y=" + CStr(ty)
    frmEmpCmd.SubmitEmpireCommand strCmd, True
        
    'Now get rid of dummy harbor
    Set rs = dbEmpireCopy.OpenRecordset("Sectors")
    rs.Index = "PrimaryKey"
    rs.Seek "=", sx, sy
    If rs.NoMatch Then
        strCmdDes = "designate " + SectorString(tx, ty) + " ."
        frmEmpCmd.SubmitEmpireCommand strCmdDes, True
    Else
        For n = 0 To rs.Fields.Count - 1
            vhld(rs.Fields(n).OrdinalPosition) = rs.Fields(n).Value
        Next n
        CopySector vhld, tx, ty, 3
    End If
    Set rs = dbEmpireCopy.OpenRecordset("plane")
    rs.Index = "PrimaryKey"

    If Not (rs.BOF And rs.EOF) Then
        rs.MoveFirst
        While Not rs.EOF
            sx = cx + rs.Fields("x")
            sy = cy + rs.Fields("y")
            OffsetSectorLocation sx, sy, 0, 0
            strCmd = ":l " + SectorString(sx, sy)
            strCmd = strCmd + ":t " + CStr(rs.Fields("tech"))
            strCmd = strCmd + ":m " + CStr(rs.Fields("mob"))
            strCmd = strCmd + ":e " + CStr(rs.Fields("eff"))
            strCmd = strCmd + ":a " + CStr(rs.Fields("att"))
            strCmd = strCmd + ":d " + CStr(rs.Fields("def"))
            strCmd = strCmd + ":r " + CStr(rs.Fields("range"))
            If rs.Fields("ship") > -1 Then
                strCmd = strCmd + ":s " + CStr(rs.Fields("ship"))
            End If
            If rs.Fields("land") > -1 Then
                strCmd = strCmd + ":l " + CStr(rs.Fields("land"))
            End If
            strCmd = "edit plane " + CStr(rs.Fields("id")) + strCmd
            frmEmpCmd.SubmitEmpireCommand strCmd, True
            rs.MoveNext
        Wend
    End If
    Set rs = Nothing
    
    sx = 4
    sy = 0
    tx = cx + sx
    ty = cy + sy
    OffsetSectorLocation tx, ty, 0, 0
    
    'now scrap the filler ships
    strCmd = "scuttle plane * ?type=f1&eff=10&x=" + CStr(tx) + "&y=" + CStr(ty)
    frmEmpCmd.SubmitEmpireCommand strCmd, True
        
    'Now get rid of dummy harbor
    Set rs = dbEmpireCopy.OpenRecordset("Sectors")
    rs.Index = "PrimaryKey"
    rs.Seek "=", sx, sy
    If rs.NoMatch Then
        strCmdDes = "designate " + SectorString(tx, ty) + " ."
        frmEmpCmd.SubmitEmpireCommand strCmdDes, True
    Else
        For n = 0 To rs.Fields.Count - 1
            vhld(rs.Fields(n).OrdinalPosition) = rs.Fields(n).Value
        Next n
        CopySector vhld, tx, ty, 3
    End If
End If

dbEmpireCopy.Close

'database update
frmEmpCmd.SubmitEmpireCommand "db1", False
frmEmpCmd.SubmitEmpireCommand "dump * ?timestamp>" + CStr(tsSectors), False
frmEmpCmd.SubmitEmpireCommand "db2", False

End Sub

Public Function DefenseStrength(Sector As String) As Single

Dim sector_strength As Single
Dim d_dstr As Single
Dim sct_effic As Single
Dim sct_type As String
Dim sx As Integer
Dim sy As Integer

If Not ParseSectors(sx, sy, Sector) Then
    DefenseStrength = 1
    Exit Function
End If

rsEnemySect.Seek "=", sx, sy
If rsEnemySect.NoMatch Then
    DefenseStrength = 1
    Exit Function
End If
sct_effic = CSng(val(rsEnemySect.Fields("eff")))
sct_type = rsEnemySect.Fields("des")


If sct_effic < 0 Then sct_effic = 100#
sector_strength = 1#
If sct_type = "^" Then
    sector_strength = 2#
End If

d_dstr = SectorDefenseStrength(sct_type)
   
DefenseStrength = sector_strength + (d_dstr - sector_strength) * (sct_effic / 100#)

End Function

Public Function EnemyMil(Sector As String) As Integer
Dim sx As Integer
Dim sy As Integer

If Not ParseSectors(sx, sy, Sector) Then
    EnemyMil = -1
    Exit Function
End If

rsEnemySect.Seek "=", sx, sy
If rsEnemySect.NoMatch Then
    EnemyMil = -1
    Exit Function
End If
EnemyMil = CSng(val(rsEnemySect.Fields("mil")))
End Function
