VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.1#0"; "COMCTL32.OCX"
Begin VB.Form frmReport 
   Caption         =   "Reports"
   ClientHeight    =   5805
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8490
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5805
   ScaleWidth      =   8490
   StartUpPosition =   3  'Windows Default
   Begin ComctlLib.Toolbar tbToolBar 
      Align           =   1  'Align Top
      Height          =   720
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   8490
      _ExtentX        =   14975
      _ExtentY        =   1270
      ButtonWidth     =   1799
      ButtonHeight    =   1111
      Appearance      =   1
      ImageList       =   "imlIcons"
      _Version        =   327680
      BeginProperty Buttons {0713E452-850A-101B-AFC0-4210102A8DA7} 
         NumButtons      =   5
         BeginProperty Button1 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Caption         =   "Save to Disk"
            Key             =   "Save"
            Description     =   ""
            Object.ToolTipText     =   "Save to Disk"
            Object.Tag             =   ""
            ImageIndex      =   1
         EndProperty
         BeginProperty Button2 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Caption         =   "Copy"
            Key             =   "Copy"
            Description     =   ""
            Object.ToolTipText     =   "Copy to Clipboard"
            Object.Tag             =   ""
            ImageIndex      =   2
         EndProperty
         BeginProperty Button3 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Caption         =   "Save to Log"
            Key             =   "File"
            Description     =   ""
            Object.ToolTipText     =   "Copy to Telegram File"
            Object.Tag             =   ""
            ImageIndex      =   3
         EndProperty
         BeginProperty Button4 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Caption         =   ""
            Key             =   ""
            Description     =   ""
            Object.ToolTipText     =   ""
            Object.Tag             =   ""
            Style           =   3
         EndProperty
         BeginProperty Button5 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Caption         =   "Close"
            Key             =   "Exit"
            Description     =   ""
            Object.ToolTipText     =   "Exit "
            Object.Tag             =   ""
            ImageIndex      =   4
         EndProperty
      EndProperty
      MouseIcon       =   "frmReport.frx":0000
   End
   Begin MSComDlg.CommonDialog cd1 
      Left            =   7920
      Top             =   4560
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "Command1"
      Height          =   615
      Left            =   480
      TabIndex        =   2
      Top             =   4680
      Visible         =   0   'False
      Width           =   1335
   End
   Begin VB.ListBox lstReport 
      Height          =   3660
      Left            =   0
      MultiSelect     =   2  'Extended
      TabIndex        =   0
      Top             =   480
      Width           =   8415
   End
   Begin ComctlLib.ImageList imlIcons 
      Left            =   7920
      Top             =   5040
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   24
      ImageHeight     =   22
      MaskColor       =   12632256
      _Version        =   327680
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   4
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "frmReport.frx":001C
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "frmReport.frx":055E
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "frmReport.frx":0AA0
            Key             =   ""
         EndProperty
         BeginProperty ListImage4 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "frmReport.frx":0C3A
            Key             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frmReport"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim TextMaxWidth As Integer
Dim TextLines As Integer
Dim SavedOnce As Boolean

Private Sub Form_Activate()
Dim nLen As Long

'If mimimized for some reason, pop it up
If Me.WindowState = vbMinimized Then
    Me.WindowState = vbNormal
    Exit Sub
End If

If TextMaxWidth < cmdOK.Width * 4 Then
    TextMaxWidth = cmdOK.Width * 4
End If

If TextMaxWidth > 0 Then
    If TextMaxWidth > ((Screen.Width * 4) / 5) Then
        TextMaxWidth = (Screen.Width * 4) / 5
    End If
            
    Me.Width = TextMaxWidth * 1.15
    Me.Left = (Screen.Width - Me.Width) \ 2
End If

If TextLines > 1 Then
    nLen = Me.TextHeight("XX") * (TextLines + 2)
    lstReport.Height = nLen
    If lstReport.Height > ((Screen.Height * 3) / 4) Then
        lstReport.Height = (Screen.Height * 3) / 4
    End If
    
    Me.Height = lstReport.Height + tbToolBar.Height * 2
    Me.top = (Screen.Height - Me.Height) \ 2
End If

End Sub

Private Sub Form_Load()
Me.Left = (Screen.Width - Me.Width) \ 2
Me.top = (Screen.Height - Me.Height) \ 2
TextLines = 0
SavedOnce = False

End Sub

Private Sub Form_Resize()

If Me.WindowState <> vbNormal Then
    Exit Sub
End If

'Check for minimum width, height
If Me.Width < (cmdOK.Width * 3) Then
    Me.Width = cmdOK.Width * 3
End If

If Me.Height < (cmdOK.Height * 5) Then
    Me.Height = cmdOK.Height * 5
End If

'Position tool bar
tbToolBar.Move 0, 0

'Position text Box
lstReport.Move 0, tbToolBar.Height, Me.ScaleWidth, Me.ScaleHeight - tbToolBar.Height

End Sub

Public Sub ClearReport()
'clear text box
lstReport.Clear
TextMaxWidth = 0
TextLines = 0
End Sub

Public Sub AddReportLine(strLine As String)

On Error GoTo AddReportLine_exit

If frmEmpCmd.SubmittedFromCommandLine Then
    Exit Sub
End If

'Add line to text box
lstReport.AddItem strLine
TextLines = TextLines + 1

Dim x As Integer
x = frmReport.TextWidth(strLine)

If x > TextMaxWidth Then
    TextMaxWidth = x
End If

If Me.WindowState = vbMinimized Then
    Me.WindowState = vbNormal
End If

If TextLines > 1 Then
    nLen = Me.TextHeight("XX") * (TextLines + 2)
    If lstReport.Height < nLen Then
    
        lstReport.Height = nLen
        If lstReport.Height > ((Screen.Height * 3) / 4) Then
            lstReport.Height = (Screen.Height * 3) / 4
        End If
        
        Me.Height = lstReport.Height + tbToolBar.Height * 2
        Me.top = (Screen.Height - Me.Height) \ 2
    End If
End If
AddReportLine_exit:
End Sub

Private Sub lstReport_KeyPress(KeyAscii As Integer)

Dim txtstring As String

'Trap Control C and Copy to Clipboard
If KeyAscii = 3 Then
    CopyListBoxToClipboard lstReport
End If

End Sub


Private Sub tbToolBar_ButtonClick(ByVal Button As ComctlLib.Button)

Select Case Button.Key
    Case "Save"
            ButtonSave
    Case "Copy"
            CopyListBoxToClipboard lstReport
    Case "File"
            ButtonFile
    Case "Exit"
            Unload Me
End Select
End Sub

Private Sub ButtonFile()

If SavedOnce Then
    Exit Sub
End If

' Copy Selected text into a sring
IncomingTelgramLine "> Saved " + Me.Caption + "  dated " _
    + Format(DateAdd("n", TimeZoneAdj, Now), "ddd mmm dd hh:mm:ss yyyy"), True, True
Dim x As Integer
For x = 0 To (lstReport.ListCount - 1)
    IncomingTelgramLine lstReport.List(x), False, True
Next x
SavedOnce = True
End Sub

Private Sub ButtonSave()

cd1.CancelError = True
On Error GoTo ErrHandler
' Set flags
cd1.FLAGS = cdlOFNHideReadOnly
' Set filters
cd1.Filter = "All Files (*.*)|*.*|Text Files" & _
"(*.txt)|*.txt|Batch Files (*.bat)|*.bat"
' Specify default filter
cd1.FilterIndex = 2
' Set default file name
cd1.filename = Me.Caption

' Display the Open dialog box
cd1.ShowSave
' Display name of selected file

On Error GoTo 0

Dim filename As String
Dim strReply As Integer

strfile = cd1.filename

'Append file suffix if necessary
If InStr(strfile, ".") = 0 Then
    strfile = strfile + ".txt"
End If

'If already exists, then prompt
strReply = vbNo
If Len(Dir(strfile)) > 0 Then

    Reply = MsgBox("File " + strfile + " alreay exists.  Do you wish to " + _
        "append this report to the file ?  (Take Yes to Append, No to Replace, " + _
        "Cancel to Exit", vbYesNoCancel, "File Exists")
        
    If Reply = vbCancel Then
        Exit Sub
    End If
End If

Dim filenum As Integer
Dim x As Integer

filenum = FreeFile
If Reply = vbYes Then
    Open strfile For Append As #filenum
Else
    Open strfile For Output As #filenum
End If

'Write output to file
For x = 0 To (lstReport.ListCount - 1)
    Print #filenum, lstReport.List(x)
Next x

Close filenum
Exit Sub
    
ErrHandler:
    'User pressed the Cancel button
Exit Sub
End Sub
